<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00001101RelatorioCustomizavelPropostaFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getRelatorioCustomizavelProposta($filtro)
    {

        $sql = "SELECT DISTINCT ORC.NRSEQORCAMENTO,
                    ORC.NRORCAMENTOMODELO,
                    ORC.NRORG,
                    ORC.NRORCAMENTO,
                    ORC.NRVERSAOORCAMENTO,
                    ORC.IDSITUACAOORCAMENTO,
                    ORC.DTREFORCAMENTO,
                    ORC.DTACEITEORCA,
                    ORC.CDOPERRESPONSAVEL,
                    ORC.NRPARCNEGOCIO,
                    ORC.DTVALIDADE, 
                    ORC.IDATIVO,
                    ORC.DTINCLUSAO,
                    ORC.NRORGINCLUSAO,
                    ORC.NRSEQORCAMENTOPAI,
                    ORC.IDGERACONTRATO,
                    ORC.NRSEQINTERLOCUTOR,
                    ORC.DSREFERENCIAORCA,
                    ORC.CDPRECBASESERV,
                    NVL(ORC.VRORCAMENTO, 0) AS VRORCAMENTO,
                    MODELO.NMORCAMENTOMODELO,
                    PARC.NMPRINCIPALPARC,
                    MODELO.IDUTILIZACOMP,
                    ORC.NRTIPOORCAMENTO,
                    ORC.CDFILIAL,
                    MEDIDA.CDTPMEDIDAVARIAVEL AS CDTPMEDIDASERV,
                    OPORT.NRSEQOPORT,
                    VENDEDOR.NRPARCVENDEDOR AS NRVENDEDOR,
                    ELEMENTO.IDELEMENTO,
                    NVL(ORC.NMPARCINTERLOCUTOR, INTERLOCUTOR.NMINTERLOCUTOR) AS NMPARCINTERLOCUTOR,
                    (SELECT LISTAGG(ESCOPO.NMTIPOORCAMENTO) WITHIN GROUP (ORDER BY ESCOPO.NMTIPOORCAMENTO)
                    FROM FCT_RELACESCOPOPROPOSTA REL
                    LEFT JOIN FCT_TIPOORCAMENTO ESCOPO
                        ON REL.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO
                    WHERE NRSEQORCAMENTO = ORC.NRSEQORCAMENTO) AS NMTIPOORCAMENTO,
                    (SELECT LISTAGG(ESCOPO.IDUTILIZAVARPRECO, ',') WITHIN GROUP( ORDER BY ESCOPO.NMTIPOORCAMENTO) 
                    FROM FCT_TIPOORCAMENTO ESCOPO 
                    INNER JOIN FCT_RELACESCOPOPROPOSTA REL 
                        ON ESCOPO.NRTIPOORCAMENTO = REL.NRTIPOORCAMENTO 
                    WHERE REL.NRSEQORCAMENTO = ORC.NRSEQORCAMENTO) AS IDUTILIZAVARPRECO,
                    (SELECT COUNT(*)
                    FROM FCT_ITEMORCAMENTO 
                    WHERE NRSEQORCAMENTO = ORC.NRSEQORCAMENTO
                        AND IDELEMENTO IS NOT NULL) AS QTITENSTRABSERV
                        FROM FCT_ORCAMENTO ORC 
                            LEFT JOIN PARCNEGOCIO PARC
                                ON ORC.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                            LEFT JOIN FCT_ORCAMENTOMODELO MODELO
                                ON ORC.NRORCAMENTOMODELO = MODELO.NRORCAMENTOMODELO
                            LEFT JOIN FCT_RELACESCOPOPROPOSTA REL
                                ON ORC.NRSEQORCAMENTO = REL.NRSEQORCAMENTO
                            LEFT JOIN FILIAL
                                ON REL.CDFILIAL = FILIAL.CDFILIAL
                            LEFT JOIN OPERADOR OPER
                                ON ORC.CDOPERRESPONSAVEL = OPER.CDOPERADOR
                            LEFT JOIN FCT_ITEMORCAMENTO ITEM
                                ON ORC.NRSEQORCAMENTO    = ITEM.NRSEQORCAMENTO   
                            LEFT JOIN FCT_TIPOMEDIDASERV ITEMMED
                                ON ITEM.CDTPMEDIDAVARIAVEL = ITEMMED.CDTPMEDIDASERV
                            LEFT JOIN FCT_TRABSERVORCAMENTO ELEMENTO
                                ON ORC.NRSEQORCAMENTO    = ELEMENTO.NRSEQORCAMENTO    
                                AND ELEMENTO.IDELEMENTO   IS NOT NULL
                                AND ELEMENTO.IDATIVO      = 'S'
                                AND ELEMENTO.IDESCOLHIDO  = 'S'
                            LEFT JOIN FCT_RELACMEDIDAPROPOSTA MEDIDA
                                ON ORC.NRSEQORCAMENTO = MEDIDA.NRSEQORCAMENTO
                            LEFT JOIN CRM_INTERLOCUTOR INTERLOCUTOR
                                ON ORC.NRSEQINTERLOCUTOR = INTERLOCUTOR.NRSEQINTERLOCUTOR
                            LEFT JOIN CRM_OPORTUNI OPORT
                                ON ORC.NRSEQOPORT = OPORT.NRSEQOPORT
                            LEFT JOIN FCT_VENDEDORORCA VENDEDOR
                                ON ORC.NRSEQORCAMENTO = VENDEDOR.NRSEQORCAMENTO
                                $filtro";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }


    public function getOportunidadeNegocio()
    {
        $sql = "SELECT  OP.NRSEQOPORT,
                        OP.NMOPORT,
                        OP.NRPARCOPORT,
                        PARC.NMPRINCIPALPARC AS NMPARCOPORT,
                        OP.IDTPOPORT,
                        OP.NRPARCRESP,
                        OP.DTPREVFECHA,
                        OP.CDMODODIVULG,
                        OP.IDPARTPEPELINE,
                        OP.DTREALFECHA,
                        OP.NRSEQRESULEVOL,
                        OP.NRPARCCONC,
                        OP.DSOPORT,
                        OP.VROPORT,
                        OP.NRSEQFASENEGO,
                        OP.CDFILIAL,
                        OP.NRCONTATO,
                        OP.NRORG,
                        OP.IDATIVO,
                        OP.DTINCLUSAO,
                        OP.DTULTATU,
                        OP.NRORGINCLUSAO,
                        OP.CDOPERINCLUSAO,
                        OP.NRORGULTATU,
                        OP.CDOPERULTATU,
                        OP.NRSEQCONTATO,
                        OP.NRSEQCLASSOPORT
                FROM CRM_OPORTUNI OP
                INNER JOIN PARCNEGOCIO PARC ON OP.NRPARCOPORT = PARC.NRPARCNEGOCIO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getVendedor()
    {
        $sql = "SELECT PARC.NRPARCNEGOCIO,
                        PARC.NMPRINCIPALPARC,
                        PARC.NRINSCRICAOPARC,
                        VEN.CDVENDEDOR,
                        PARC.NRORG
                FROM PARCNEGOCIO PARC
                INNER JOIN PARCERIA ON PARC.NRPARCNEGOCIO = PARCERIA.NRPARCNEGOCIO
                INNER JOIN VENDEDOR VEN ON PARC.NRPARCNEGOCIO = VEN.NRPARCNEGOCIO
                WHERE PARCERIA.CDTIPOPARCEIRO = 'VENDEDOR'
                AND PARCERIA.IDATIVO = 'S'
                AND PARC.IDATIVO = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getItensRelatorioCustomizavel($filtro)
    {
        $sql = "SELECT FCT_ITEMORCAMENTO.NRITEMORCAMENTO, FCT_ITEMORCAMENTO.NRSEQORCAMENTO, FCT_ITEMORCAMENTO.CDSERVORCA, FCT_ITEMORCAMENTO.NRITEMORCAMENTOPAI, FCT_ITEMORCAMENTO.NMITEMORCAMENTO,
                        FCT_ITEMORCAMENTO.CDTPMEDIDASERV, FCT_ITEMORCAMENTO.QTMEDIDAORCA, FCT_ITEMORCAMENTO.VRTOTALITEMORCA, FCT_ITEMORCAMENTO.IDELEMENTO, FCT_ORCAMENTO.NRORCAMENTO, FCT_TIPOMEDIDASERV.DSTPMEDIDASERV
                FROM FCT_ITEMORCAMENTO
                LEFT JOIN FCT_ORCAMENTO
                  ON FCT_ORCAMENTO.NRSEQORCAMENTO = FCT_ITEMORCAMENTO.NRSEQORCAMENTO
                LEFT JOIN FCT_TIPOMEDIDASERV
                  ON FCT_TIPOMEDIDASERV.CDTPMEDIDASERV = FCT_ITEMORCAMENTO.CDTPMEDIDASERV               
                $filtro";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
