<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use \Teknisa\Model\Traits\TQuery;

class Sm00029000LocalAtendimentoFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getTipLocAtendEstruturam()
    {
        $sql = "SELECT
                    ES.NRESTRUTURAM,
                    ES.IDATIVO,
                    ES.NMESTRUTURAM,
                    EH.NRESTRUTURAH,
                    ES.NRTIPOESTRUTURA,
                    ES.NMRAZSOCFILI,
                    TE.NMTIPOESTRUTURA,
                    PARC.NRINSCRICAOPARC,
                    PARC.CDTIPOINSCRICAO,
                    ES.CDINTESTRUTURA,
                    ES.NRPARCNEGOCIO,
                    ES.DSESTRUTURA,
                    ES.NRORG,
                    ES.DTINCLUSAO,
                    ES.CDOPERINCLUSAO,
                    ES.NRORGINCLUSAO,
                    ES.DTULTATU,
                    ES.CDOPERULTATU,
                    ES.NRORGULTATU,
                    H.NRHIERARQUIAORG,
                    H.NRESTRUTURAMSUP,
                    ENDE.NRENDERECOPARC,
                    ENDE.DSENDERECO,
                    ENDE.NRIMOVELENDERECO,
                    ENDE.DSCOMPLEENDERECO,
                    ENDE.CDPAIS,
                    PAIS.NMPAIS                AS NMPAIS,
                    ENDE.SGESTADO,
                    ESTADO.NMESTADO            AS NMESTADO,
                    ENDE.CDMUNICIPIO,
                    MUNICIPIO.NMMUNICIPIO      AS NMMUNICIPIO,
                    ENDE.CDBAIRRO,
                    ENDE.NMBAIRROENDERECO AS NMBAIRRO,
                    ENDE.NMBAIRROENDERECO,
                    ENDE.NRCEPENDERECO,
                    ENDE.DSREFERENCIAENDE,
                    ENDE.DSLATITUDE,
                    ENDE.DSLONGITUDE,
                    ENDECOB.NRENDERECOPARC     AS NRENDERECOPARC_COBRANCA,
                    ENDECOB.DSENDERECO         AS DSENDERECO_COBRANCA,
                    ENDECOB.NRIMOVELENDERECO   AS NRIMOVELENDERECO_COBRANCA,
                    ENDECOB.DSCOMPLEENDERECO   AS DSCOMPLEENDERECO_COBRANCA,
                    ENDECOB.CDPAIS             AS CDPAIS_COBRANCA,
                    PAISCOB.NMPAIS             AS NMPAIS_COBRANCA,
                    ENDECOB.SGESTADO           AS SGESTADO_COBRANCA,
                    ESTADOCOB.NMESTADO         AS NMESTADO_COBRANCA,
                    ENDECOB.CDMUNICIPIO        AS CDMUNICIPIO_COBRANCA,
                    MUNICIPIOCOB.NMMUNICIPIO   AS NMMUNICIPIO_COBRANCA,
                    ENDECOB.CDBAIRRO           AS CDBAIRRO_COBRANCA,
                    ENDECOB.NMBAIRROENDERECO   AS NMBAIRROENDERECO_COBRANCA,
                    ENDECOB.NRCEPENDERECO      AS NRCEPENDERECO_COBRANCA,
                    ENDECOB.DSREFERENCIAENDE   AS DSREFERENCIAENDE_COBRANCA,
                    ENDEEXT.NRENDERECOPARC     AS NRENDERECOPARC_EXTERIOR,
                    ENDEEXT.DSENDERECO         AS DSENDERECO_EXTERIOR,
                    ENDEEXT.NRIMOVELENDERECO   AS NRIMOVELENDERECO_EXTERIOR,
                    ENDEEXT.DSCOMPLEENDERECO   AS DSCOMPLEENDERECO_EXTERIOR,
                    ENDEEXT.CDPAIS             AS CDPAIS_EXTERIOR,
                    PAISEXT.NMPAIS             AS NMPAIS_EXTERIOR,
                    ENDEEXT.SGESTADO           AS SGESTADO_EXTERIOR,
                    ESTADOEXT.NMESTADO         AS NMESTADO_EXTERIOR,
                    ENDEEXT.CDMUNICIPIO        AS CDMUNICIPIO_EXTERIOR,
                    MUNICIPIOEXT.NMMUNICIPIO   AS NMMUNICIPIO_EXTERIOR,
                    ENDEEXT.CDBAIRRO           AS CDBAIRRO_EXTERIOR,
                    ENDEEXT.NMBAIRROENDERECO   AS NMBAIRROENDERECO_EXTERIOR,
                    ENDEEXT.NRCEPENDERECO      AS NRCEPENDERECO_EXTERIOR,
                    ENDEEXT.DSREFERENCIAENDE   AS DSREFERENCIAENDE_EXTERIOR,
                    ENDEENT.NRENDERECOPARC     AS NRENDERECOPARC_ENTREGA,
                    ENDEENT.DSENDERECO         AS DSENDERECO_ENTREGA,
                    ENDEENT.NRIMOVELENDERECO   AS NRIMOVELENDERECO_ENTREGA,
                    ENDEENT.DSCOMPLEENDERECO   AS DSCOMPLEENDERECO_ENTREGA,
                    ENDEENT.CDPAIS             AS CDPAIS_ENTREGA,
                    PAISENT.NMPAIS             AS NMPAIS_ENTREGA,
                    ENDEENT.SGESTADO           AS SGESTADO_ENTREGA,
                    ESTADOENT.NMESTADO         AS NMESTADO_ENTREGA,
                    ENDEENT.CDMUNICIPIO        AS CDMUNICIPIO_ENTREGA,
                    MUNICIPIOENT.NMMUNICIPIO   AS NMMUNICIPIO_ENTREGA,
                    ENDEENT.CDBAIRRO           AS CDBAIRRO_ENTREGA,
                    ENDEENT.NMBAIRROENDERECO   AS NMBAIRROENDERECO_ENTREGA,
                    ENDEENT.NRCEPENDERECO      AS NRCEPENDERECO_ENTREGA,
                    ENDEENT.DSREFERENCIAENDE   AS DSREFERENCIAENDE_ENTREGA,
                    ES.CDCENTCUST,
                    CC.NMCENTCUST              AS NMCENTCUST,
                    ES.DSURLLOGOESTRUTURA,
                    ESSUP.NMESTRUTURAM         AS NMESTRUTURAMSUP,
                    NVL2(PARCERIA.NRPARCERIA, 'S', 'N') AS IDCONVERTIDOCLIENTE,
                    NVL2(ES.CDFILIAL, 'S', 'N') AS IDCONVERTIDOFILIAL,
                    ES.CDFILIAL,
                    FILIAL.CDINSCESTA,
                    FILIAL.CDINSCMUNI,
                    FILIAL.CDEMPRESA,
                    EMP.NMEMPRESA,
                    ES.DSEMAILESTRUTURA,
                    'S' AS IDCRIANOVOCLIENTE,
                    NULL AS NMCLIENTE,
                    NULL AS CLIENTE,
                    'S' AS IDCRIANOVAUNIDADE,
                    NULL AS FILIAL,
                    NULL AS NMFILIAL
                FROM
                    ESTRUTURAM      ES
                    LEFT JOIN ESTRUTURAH      EH ON ES.NRESTRUTURAM = EH.NRESTRUTURAM
                    LEFT JOIN TIPOESTRUTURA   TE ON TE.NRTIPOESTRUTURA = ES.NRTIPOESTRUTURA
                    LEFT JOIN CENTCUST        CC ON ES.CDCENTCUST = CC.CDCENTCUST
                    LEFT JOIN HIERARQUIAORG   H ON ES.NRESTRUTURAM = H.NRESTRUTURAMREL
                    LEFT JOIN PARCNEGOCIO     PARC ON ES.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                    LEFT JOIN ENDERECOPARC    ENDE ON PARC.NRPARCNEGOCIO = ENDE.NRPARCNEGOCIO
                                                AND ENDE.CDTIPOENDERECO = 'PRINCIPAL'
                                                AND ENDE.IDATIVO = 'S'
                    LEFT JOIN PAIS ON PAIS.CDPAIS = ENDE.CDPAIS
                    LEFT JOIN ESTADO ON ESTADO.SGESTADO = ENDE.SGESTADO
                                        AND ESTADO.CDPAIS = ENDE.CDPAIS
                    LEFT JOIN MUNICIPIO ON MUNICIPIO.CDMUNICIPIO = ENDE.CDMUNICIPIO
                                        AND MUNICIPIO.SGESTADO = ENDE.SGESTADO
                                        AND MUNICIPIO.CDPAIS = ENDE.CDPAIS
                    LEFT JOIN ENDERECOPARC    ENDECOB ON PARC.NRPARCNEGOCIO = ENDECOB.NRPARCNEGOCIO
                                                    AND ENDECOB.CDTIPOENDERECO = 'COBRANCA'
                                                    AND ENDECOB.IDATIVO = 'S'
                    LEFT JOIN PAIS            PAISCOB ON PAISCOB.CDPAIS = ENDECOB.CDPAIS
                    LEFT JOIN ESTADO          ESTADOCOB ON ESTADOCOB.SGESTADO = ENDECOB.SGESTADO
                                                AND ESTADOCOB.CDPAIS = ENDECOB.CDPAIS
                    LEFT JOIN MUNICIPIO       MUNICIPIOCOB ON MUNICIPIOCOB.CDMUNICIPIO = ENDECOB.CDMUNICIPIO
                                                        AND MUNICIPIOCOB.SGESTADO = ENDECOB.SGESTADO
                                                        AND MUNICIPIOCOB.CDPAIS = ENDECOB.CDPAIS
                    LEFT JOIN ENDERECOPARC    ENDEEXT ON PARC.NRPARCNEGOCIO = ENDEEXT.NRPARCNEGOCIO
                                                    AND ENDEEXT.CDTIPOENDERECO = 'EXTERIOR'
                                                    AND ENDEEXT.IDATIVO = 'S'
                    LEFT JOIN PAIS            PAISEXT ON PAISEXT.CDPAIS = ENDEEXT.CDPAIS
                    LEFT JOIN ESTADO          ESTADOEXT ON ESTADOEXT.SGESTADO = ENDEEXT.SGESTADO
                                                AND ESTADOEXT.CDPAIS = ENDEEXT.CDPAIS
                    LEFT JOIN MUNICIPIO       MUNICIPIOEXT ON MUNICIPIOEXT.CDMUNICIPIO = ENDEEXT.CDMUNICIPIO
                                                        AND MUNICIPIOEXT.SGESTADO = ENDEEXT.SGESTADO
                                                        AND MUNICIPIOEXT.CDPAIS = ENDEEXT.CDPAIS
                    LEFT JOIN ENDERECOPARC    ENDEENT ON PARC.NRPARCNEGOCIO = ENDEENT.NRPARCNEGOCIO
                                                    AND ENDEENT.CDTIPOENDERECO = 'ENTREGA'
                                                    AND ENDEENT.IDATIVO = 'S'
                    LEFT JOIN PAIS            PAISENT ON PAISENT.CDPAIS = ENDEENT.CDPAIS
                    LEFT JOIN ESTADO          ESTADOENT ON ESTADOENT.SGESTADO = ENDEENT.SGESTADO
                                                AND ESTADOENT.CDPAIS = ENDEENT.CDPAIS
                    LEFT JOIN MUNICIPIO       MUNICIPIOENT ON MUNICIPIOENT.CDMUNICIPIO = ENDEENT.CDMUNICIPIO
                                                        AND MUNICIPIOENT.SGESTADO = ENDEENT.SGESTADO
                                                        AND MUNICIPIOENT.CDPAIS = ENDEENT.CDPAIS
                    LEFT JOIN ESTRUTURAM      ESSUP ON H.NRESTRUTURAMSUP = ESSUP.NRESTRUTURAM
                    LEFT JOIN PARCERIA ON ES.NRPARCNEGOCIO = PARCERIA.NRPARCNEGOCIO
                                        AND PARCERIA.CDTIPOPARCEIRO = 'CLIENTE'
                                        AND PARCERIA.IDATIVO = 'S'
                    LEFT JOIN FILIAL ON ES.CDFILIAL = FILIAL.CDFILIAL
                    LEFT JOIN EMPRESA         EMP ON FILIAL.CDEMPRESA = EMP.CDEMPRESA
                WHERE
                    ES.NMESTRUTURAM IS NOT NULL
                        ORDER BY ES.NMESTRUTURAM ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTipoLocalAtendimento()
    {

        $sql = "SELECT
                    NRTIPOESTRUTURA,
                    NMTIPOESTRUTURA,
                    IDMULTIOCORRENC,
                    NRORG,
                    IDATIVO,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU
                FROM
                    TIPOESTRUTURA 
                        ORDER BY NMTIPOESTRUTURA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findLocalAtendimentoCentroCusto()
    {

        $sql = "SELECT DISTINCT
                    CENTCUST.CDCENTCUST,
                    CENTCUST.CDCENTCUST || ' - ' || CENTCUST.NMCENTCUST AS NMCENTCUST,
                    CENTCUST.NRORG
                FROM
                    CENTCUST
                    ORDER BY NMCENTCUST ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findPais()
    {

        $sql = "SELECT 
                    CDPAIS,
                    NMPAIS,
                    CDPAIS AS CDPAIS_COBRANCA,
                    NMPAIS AS NMPAIS_COBRANCA,
                    CDPAIS AS CDPAIS_EXTERIOR,
                    NMPAIS AS NMPAIS_EXTERIOR,
                    CDPAIS AS CDPAIS_ENTREGA,
                    NMPAIS AS NMPAIS_ENTREGA,
                    DTULTATUPAIS,
                    CDDDIPAIS,
                    CDPAISEXPFIS,
                    CDPAISBACEN,
                    SGPAIS,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDATIVO,
                    CDPAISGMB,
                    CDESOCIAL
                FROM PAIS
                    ORDER BY NMPAIS ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findEstado($param)
    {
        $sql = "SELECT 
                    CDPAIS,
                    SGESTADO,
                    NMESTADO,
                    SGESTADO AS SGESTADO_COBRANCA,
                    NMESTADO AS NMESTADO_COBRANCA,
                    SGESTADO AS SGESTADO_EXTERIOR,
                    NMESTADO AS NMESTADO_EXTERIOR,
                    SGESTADO AS SGESTADO_ENTREGA,
                    NMESTADO AS NMESTADO_ENTREGA,
                    CDESTAEXPO,
                    DTULTATUESTA,
                    CDESTADOIBGE,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDUTHORVER,
                    HRDIFUTCFUSO,
                    IDATIVO,
                    CDESTADOGMB
                FROM ESTADO
                    WHERE IDATIVO = 'S'
                    AND CDPAIS = :CDPAIS
                    ORDER BY NMESTADO ASC";
                    // var_dump($param);

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $param);
    }

    public function findMunicipio($param)
    {

        $sql = "SELECT 
                    DTINCLUSAO,
                    NRORG,
                    IDMUNIUTCONVNFE,
                    CDDDDMUNICIP,
                    CDREGIAO,
                    DTULTATUMUNI,
                    CDMUNIEXPO,
                    IDMUNIALC,
                    CDMUNICIBGE,
                    NMMUNICIPIO,
                    CDMUNICIPIO,
                    NMMUNICIPIO AS NMMUNICIPIO_COBRANCA,
                    CDMUNICIPIO AS CDMUNICIPIO_COBRANCA,
                    NMMUNICIPIO AS NMMUNICIPIO_EXTERIOR,
                    CDMUNICIPIO AS CDMUNICIPIO_EXTERIOR,
                    NMMUNICIPIO AS NMMUNICIPIO_ENTREGA,
                    CDMUNICIPIO AS CDMUNICIPIO_ENTREGA,
                    SGESTADO,
                    CDPAIS,
                    CDMUNICSIAFI,
                    CDMUNICIPIOGMB,
                    IDATIVO,
                    CDOPERULTATU,
                    NRORGULTATU,
                    CDOPERINCLUSAO,
                    NRORGINCLUSAO,
                    DTULTATU
                FROM MUNICIPIO
                    WHERE IDATIVO = 'S'
                    AND CDPAIS = :CDPAIS
                    AND SGESTADO = :SGESTADO
                    ORDER BY NMMUNICIPIO ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $param);
    }

    /**
     *  Recebe as hierarquias filhas para que sejam deletadas junto com o pai.
    */
    public function recebefilhos($params){
        $sql = "SELECT LEVEL, ESTRUTURAM.NRESTRUTURAM, ESTRUTURAM.NRPARCNEGOCIO
                FROM HIERARQUIAORG 
                LEFT JOIN ESTRUTURAM
                    ON HIERARQUIAORG.NRESTRUTURAMREL = ESTRUTURAM.NRESTRUTURAM
                START WITH HIERARQUIAORG.NRESTRUTURAMREL  = :NRESTRUTURAM
                CONNECT BY PRIOR HIERARQUIAORG.NRESTRUTURAMREL = HIERARQUIAORG.NRESTRUTURAMSUP
                ORDER BY LEVEL DESC";
    
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll(); 
    } 

    /**
     * Deleta a Hierarquia da Estrutura.
     */
    public function deletarHierarquiaOrg($params){

        $sql = "DELETE FROM HIERARQUIAORG 
                WHERE ((NRESTRUTURAMREL = :NRESTRUTURAM) 
                    OR (NRESTRUTURAMSUP = :NRESTRUTURAM))";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    /**
     * Deleta a Estrutura H.
     */
    public function deletarEstruturaH($params){
        
        $sql = "DELETE FROM ESTRUTURAH
                WHERE NRESTRUTURAM = :NRESTRUTURAM";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    /**
     * Deleta a Estrutura M.
     */
    public function deletarEstruturaM($params){
        
        $sql = "DELETE FROM ESTRUTURAM
                WHERE NRESTRUTURAM = :NRESTRUTURAM";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

        
    /**
     * Deleta o endereço de Hierarquia da Estrutura.
     */
    public function deletarEnderecoParc($params){
        
        $sql = "DELETE FROM ENDERECOPARC
                WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    /**
     * Deleta o Parceiro de Negócio.
     */
    public function deletarParcNegocio($params){
        
        $sql = "DELETE FROM PARCNEGOCIO
                WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function getParcNegocioCliente()
    {

        $sql = "SELECT
                    PARCNEGOCIO.NRPARCNEGOCIO,
                    CLIENTE.CDCLIENTE,
                    CLIENTE.NRINSJURCLIE,
                    LTRIM(CLIENTE.NMRAZSOCCLIE) AS NMRAZSOCCLIE,
                    LTRIM(CLIENTE.NMFANTCLIE) AS NMFANTCLIE,
                    PARCNEGOCIO.NRORG,
                    NRINSJURCLIE || ' | ' || RTRIM(LTRIM(NMRAZSOCCLIE)) || ' | ' || RTRIM(LTRIM(NMFANTCLIE)) AS CLIENTE
                FROM
                    PARCNEGOCIO
                    JOIN CLIENTE ON PARCNEGOCIO.NRPARCNEGOCIO = CLIENTE.NRPARCNEGOCIO
                WHERE
                    CLIENTE.IDCLIEATIV = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getLocalAtendimentoFilial()
    {
        $sql = "SELECT
                    CDFILIAL,
                    NMFILIAL,
                    CDFILIAL || ' | ' || RTRIM(LTRIM(NMFILIAL)) AS FILIAL,
                    NRINSJURFILI,
                    CDFILIFISC,
                    CDEMPRESA,
                    CDINSCMUNI,
                    CDINSCESTA,
                    IDTPIJURFILI,
                    IDCNTRRESC,
                    NMRAZSOCFILI,
                    CDTPCONTRATO,
                    CDTPCLIENTE,
                    CDREGIAO,
                    CDGOPERAC,
                    CDSUPERVISOR,
                    CDADMINISTRA,
                    CDAREAGERE,
                    CDCONTCTBL,
                    IDENDEMISFIL,
                    IDENDCFOPFIL,
                    CDSERIE,
                    CDFILCENTCMP,
                    DTULTATUFILI,
                    CDSEGMER,
                    CDGRUPOFISC,
                    CDEMPRESAP,
                    CDCENTCUST,
                    IDUTFILIPADR,
                    DTINCONTRFIL,
                    DTFICONTRFIL,
                    IDFUNCAOFILI,
                    VRPECOVENFIL,
                    CDFILCENTPME,
                    IDFILCENTPME,
                    NMCOMPRZSFIL,
                    VRPECREPREST,
                    CDEANFILIAL,
                    QTFUNCFILI,
                    CDFORNOPELOG,
                    DTINICIALBI,
                    CDREDUCONT,
                    NRINSCSUFRAMAFI,
                    DTINIUTILIZANFE,
                    NRMESREAJCONTR,
                    CDPRECOBASE,
                    IDATIVO,
                    NRPARCNEGOCIO,
                    CDFILIALEXT,
                    IDCOMPARQXMLFIL,
                    IDCONSORCFIL,
                    VRPEORCBLOQFIL,
                    VRPEORCALERTFIL,
                    IDCUMUPISCOFIL,
                    IDUTILOFFLINE,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDCALCOMESTORC,
                    VRPERCORCOMFJAN,
                    VRPERCORCOMFFEV,
                    VRPERCORCOMFMAR,
                    VRPERCORCOMFABR,
                    VRPERCORCOMFMAI,
                    VRPERCORCOMFJUN,
                    VRPERCORCOMFJUL,
                    VRPERCORCOMFAGO,
                    VRPERCORCOMFSET,
                    VRPERCORCOMFOUT,
                    VRPERCORCOMFNOV,
                    VRPERCORCOMFDEZ,
                    DTEXPFILISAGA,
                    CDPLANEJADORA,
                    CDGUNIDADE,
                    CDGRUPOGO,
                    CDGRUPOGU,
                    CDGRUPOPLA,
                    CDGRUPOSUP,
                    CDOPGESTOEMAF,
                    IDCONSAFORCFIL,
                    SGFILIAL
                FROM FILIAL";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getLocalAtendimentoEmpresa()
    {

        $sql = "SELECT
                    CDEMPRESA,
                    CDPAIS,
                    SGESTADO,
                    CDMUNICIPIO,
                    CDCENTCUST,
                    NMEMPRESA,
                    NMRAZSOCEMPR,
                    DSENDEEMPR,
                    NMBAIREMPR,
                    NRCEPEMPR,
                    IDTPIJUREMPR,
                    NRINSJUREMPR,
                    NRINSCESTA,
                    NRREGJUNCOM,
                    DTREGJUNCOM,
                    NMCONTEMPR,
                    NRCRCCONT,
                    NMTITUEMPR,
                    CDEMPRIEST,
                    CDINSCESTA,
                    CDEMPIMUN,
                    CDINSCMUNI,
                    VRPEMULEMPR,
                    VRMULTAEMPR,
                    VRPEMOREMPR,
                    VRMORDIAEMPR,
                    CDNATUJURI,
                    CDCONTADOR2,
                    CDFPAS,
                    CDCNAE,
                    NRTELEFOEMPR,
                    DSLOGRADEMPR,
                    NRLOGRADEMPR,
                    DSCMPLOGEMPR,
                    IDPARTICIPAT,
                    IDTIPOEMPR,
                    IDOPTSIMPLES,
                    NRPROPRIEMPR,
                    MEDATABASE,
                    NRCAGED,
                    CDEMPRCAIXA,
                    VRPETXADMPOR,
                    DTULTATUEMPR,
                    DSARQRECIBO,
                    DSARQRECIREC,
                    CDBAIRRO,
                    VRPECOVENEMP,
                    CDREGIMEAPUR,
                    NMCOMPRZSEMP,
                    DSCOMPENDEMP,
                    NRREGIESPECIAL,
                    NRAIDF,
                    DTVALAIDF,
                    DTEMISAIDF,
                    QTNOTASAIDF,
                    NRINIAIDF,
                    NRFINAIDF,
                    DSEMAILEMPRESA,
                    DSENDWEBEMPR,
                    DSARQLOGOEMP,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    DSMENSEMAILNFE,
                    IDNATUOPEREMPR,
                    IDREGESPTRIBEMP,
                    DSMENSEMAILCCE,
                    CDSIMPLESNACIONAL,
                    DSMENSEMAILCANC,
                    IDATIVO,
                    IDREGIMEICMSST,
                    SGEMPRESA,
                    SGAREAGERE,
                    IDCUMUPICOEMP,
                    IDINCENTCULTURA,
                    IDINCENTFISCAL,
                    IDFORMAPUR,
                    IDFORMAPUREMPR,
                    DSENDEEMPSEP,
                    NRENDEEMPSEP,
                    NRDDDTELEEMP,
                    NRTELEEMPSEP,
                    NRRAMALTELEEMP,
                    NRDDDFAXEMP,
                    NRFAXEMPSEP,
                    NRRAMALFAXEMP,
                    CDLOGRADOURO,
                    NRFAXEMP,
                    DSMENSEMAILMDFE,
                    DSMENSEMAILCTE,
                    DSEMAILCCNFE,
                    DSASSUNTONFE,
                    DSDIRLOGOMARCA,
                    NRRNTRC,
                    CDPREFIXOGS1,
                    IDCTBBAIXAEMPR,
                    NRCLF,
                    DSARQLOGOEMPCLOB,
                    CDEXTERNO,
                    CDGRUPEMPR
                FROM EMPRESA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
    
    
    public function getLocalAtendimentoInscrEstad()
    {
        $sql = "SELECT
                    CDEMPRESA,
                    CDINSCESTA,
                    CDFILIAL,
                    NMREPRINSEST,
                    IDTPIJURIEST,
                    NRINSJURIEST,
                    CDPAIS,
                    SGESTADO,
                    CDMUNICIPIO,
                    DSENDEIEST,
                    NMBAIRIEST,
                    NRCEPIEST,
                    NRTELEIEST,
                    NRFAXIEST,
                    CDCSTDIG1SAI,
                    DTULTATUIEST,
                    CDBAIRRO,
                    DSCOMPENDIES,
                    NRSERIECERTIFIC,
                    IDTPIMPRESDANFE,
                    IDTPAMBIENTENFE,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDAPURLUCPRE,
                    CDCONTADOR2,
                    IDUTSERECFNF,
                    IDUTNRCUPOMNF,
                    IDUTCARGATRIB,
                    VRALIQTOTALSAIDA,
                    DSOUTCREDTOTSAI,
                    VRALIQIMPOSREC,
                    DSOUTCREDIMPREC,
                    CDTIPOPERCREDP,
                    IDATIVO,
                    NMCERTIFICADO,
                    CDSENHACERTIF,
                    DSOUTCREDCARGA,
                    DSOUTDEBICARGA,
                    CDAJSTCREDCARGA,
                    CDAJSTDEBICARGA,
                    IDOUTCREDDEB,
                    IDCREDDEBNORM,
                    IDSUGREGSTENTR,
                    IDCALCESTCRED,
                    DTINIESTCRED,
                    IDTPIMPRESDAMDFE,
                    IDTPAMBIENTEMDFE,
                    CDSERIEMDFE,
                    CDMODDOCFISC,
                    CDENCARGOST,
                    DTINIVIGIEST,
                    DTFIMVIGIEST,
                    IDCONSVRBCREDZ,
                    CDLOGRADOURO,
                    NRDDDTELEIEST,
                    NRDDDFAXIEST,
                    DSENDEIESTSEP,
                    NRENDEIESTSEP,
                    NRFAXIESTSEP,
                    NRTELEIESTSEP,
                    IDTPIMPRESDACTE,
                    IDTPAMBIENTECTE,
                    CDMODDOCFISCCTE,
                    CDSERIECTE,
                    DSEMAILIEMDFE,
                    IDCOMPARQXMLIE,
                    IDPRESTSERVTRANSP,
                    IDCALCDIFENTFISC,
                    DTVALIDCERTIFIC,
                    NMREQCERTIFIC,
                    OBSCONTRREFEICOES,
                    IDDIFERICMSANT,
                    DSDIRCERTIFICADO,
                    IDVERLEIAUTENFE,
                    IDREALIESTAPUR,
                    CDTPOPERESTAPUR,
                    CDCFOPESTAPUR,
                    VRALIQEFETIVA,
                    VRALIQINTERNA,
                    CDAJUSTESTAPUR,
                    DSESTORNODEBAPU,
                    VRPERCREDST
                FROM INSCRESTAD";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getLocalAtendimentoInscrMunicip()
    {

        $sql = "SELECT
                    CDEMPRESA,
                    CDINSCMUNI,
                    CDFILIAL,
                    NMREPRINSMUN,
                    DTULTATUIMUN,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    CDPAIS,
                    SGESTADO,
                    CDMUNICIPIO,
                    CDBAIRRO,
                    DSENDEIMUN,
                    NUMINSCMUN,
                    DSCOMPIMUN,
                    NRCEPIMUN,
                    NRTELEIMUN,
                    NRFAXIMUN,
                    NRDDDTELIMUN,
                    NRDDDFAXIMUN,
                    NRCERTDIGNFSE,
                    IDAMBTRABNFSE,
                    NRINSJURIMUNI,
                    IDATIVO,
                    DSENDEIMUNSEP,
                    CDLOGRADOURO,
                    DSDIRLOGOMARCA
                FROM INSCRMUNICIP";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getBairro( $filtro, $params)
    {
        $sql = "SELECT 
                    BAR.CDBAIRRO,
                    BAR.NMBAIRRO,
                    ENDEPAR.NMBAIRROENDERECO,
                    ENDEPAR.CDTIPOENDERECO,
                    BAR.CDMUNICIPIO,
                    MUNICIPIO.NMMUNICIPIO,    
                    BAR.SGESTADO,
                    ESTADO.NMESTADO,
                    BAR.CDPAIS,
                    PAIS.NMPAIS,	
                    BAR.IDATIVO,
                    BAR.CDOPERULTATU,
                    BAR.NRORGULTATU,
                    BAR.CDOPERINCLUSAO,
                    BAR.NRORGINCLUSAO,
                    BAR.DTULTATU,
                    BAR.DTINCLUSAO,
                    BAR.NRORG,
                    BAR.QTHORAENTREGA,
                    BAR.VRTXENTREGA,
                    BAR.DTULTATUBAIR,
                    BAR.CDREGIAOMUNI,
                    ENDEPAR.NRENDERECOPARC     AS NRENDERECOPARC_COBRANCA,
                    ENDEPAR.DSENDERECO         AS DSENDERECO_COBRANCA,
                    ENDEPAR.NRIMOVELENDERECO   AS NRIMOVELENDERECO_COBRANCA,
                    ENDEPAR.DSCOMPLEENDERECO   AS DSCOMPLEENDERECO_COBRANCA,
                    ENDEPAR.CDPAIS             AS CDPAIS_COBRANCA,
                    PAIS.NMPAIS                AS NMPAIS_COBRANCA,
                    ENDEPAR.SGESTADO           AS SGESTADO_COBRANCA,
                    ESTADO.NMESTADO            AS NMESTADO_COBRANCA,
                    ENDEPAR.CDMUNICIPIO        AS CDMUNICIPIO_COBRANCA,
                    MUNICIPIO.NMMUNICIPIO      AS NMMUNICIPIO_COBRANCA,
                    ENDEPAR.CDBAIRRO           AS CDBAIRRO_COBRANCA,
                    ENDEPAR.NMBAIRROENDERECO   AS NMBAIRROENDERECO_COBRANCA,
                    ENDEPAR.NRCEPENDERECO      AS NRCEPENDERECO_COBRANCA,
                    ENDEPAR.DSREFERENCIAENDE   AS DSREFERENCIAENDE_COBRANCA,
                    ENDEPAR.NRENDERECOPARC     AS NRENDERECOPARC_EXTERIOR,
                    ENDEPAR.DSENDERECO         AS DSENDERECO_EXTERIOR,
                    ENDEPAR.NRIMOVELENDERECO   AS NRIMOVELENDERECO_EXTERIOR,
                    ENDEPAR.DSCOMPLEENDERECO   AS DSCOMPLEENDERECO_EXTERIOR,
                    ENDEPAR.CDPAIS             AS CDPAIS_EXTERIOR,
                    PAIS.NMPAIS                AS NMPAIS_EXTERIOR,
                    ENDEPAR.SGESTADO           AS SGESTADO_EXTERIOR,
                    ESTADO.NMESTADO            AS NMESTADO_EXTERIOR,
                    ENDEPAR.CDMUNICIPIO        AS CDMUNICIPIO_EXTERIOR,
                    MUNICIPIO.NMMUNICIPIO      AS NMMUNICIPIO_EXTERIOR,
                    ENDEPAR.CDBAIRRO           AS CDBAIRRO_EXTERIOR,
                    ENDEPAR.NMBAIRROENDERECO   AS NMBAIRROENDERECO_EXTERIOR,
                    ENDEPAR.NRCEPENDERECO      AS NRCEPENDERECO_EXTERIOR,
                    ENDEPAR.DSREFERENCIAENDE   AS DSREFERENCIAENDE_EXTERIOR,
                    ENDEPAR.NRENDERECOPARC     AS NRENDERECOPARC_ENTREGA,
                    ENDEPAR.DSENDERECO         AS DSENDERECO_ENTREGA,
                    ENDEPAR.NRIMOVELENDERECO   AS NRIMOVELENDERECO_ENTREGA,
                    ENDEPAR.DSCOMPLEENDERECO   AS DSCOMPLEENDERECO_ENTREGA,
                    ENDEPAR.CDPAIS             AS CDPAIS_ENTREGA,
                    PAIS.NMPAIS                AS NMPAIS_ENTREGA,
                    ENDEPAR.SGESTADO           AS SGESTADO_ENTREGA,
                    ESTADO.NMESTADO            AS NMESTADO_ENTREGA,
                    ENDEPAR.CDMUNICIPIO        AS CDMUNICIPIO_ENTREGA,
                    MUNICIPIO.NMMUNICIPIO       AS NMMUNICIPIO_ENTREGA,
                    ENDEPAR.CDBAIRRO           AS CDBAIRRO_ENTREGA,
                    ENDEPAR.NMBAIRROENDERECO   AS NMBAIRROENDERECO_ENTREGA,
                    ENDEPAR.NRCEPENDERECO      AS NRCEPENDERECO_ENTREGA,
                    ENDEPAR.DSREFERENCIAENDE   AS DSREFERENCIAENDE_ENTREGA
                FROM BAIRRO BAR
                RIGHT JOIN ENDERECOPARC ENDEPAR ON BAR.CDPAIS = ENDEPAR.CDPAIS AND BAR.SGESTADO = ENDEPAR.SGESTADO AND BAR.CDMUNICIPIO = ENDEPAR.CDMUNICIPIO AND BAR.CDBAIRRO = ENDEPAR.CDBAIRRO
                LEFT JOIN PAIS ON PAIS.CDPAIS = ENDEPAR.CDPAIS
                LEFT JOIN ESTADO ON ESTADO.SGESTADO = ENDEPAR.SGESTADO AND ESTADO.CDPAIS = ENDEPAR.CDPAIS
                LEFT JOIN MUNICIPIO ON MUNICIPIO.CDMUNICIPIO = ENDEPAR.CDMUNICIPIO AND MUNICIPIO.SGESTADO = ENDEPAR.SGESTADO AND MUNICIPIO.CDPAIS = ENDEPAR.CDPAIS
                WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                AND SGESTADO = :SGESTADO
                AND CDPAIS = :CDPAIS
                AND CDMUNICIPIO = :CDMUNICIPIO
                AND  " . $filtro;

            var_dump($sql);

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    // public function findCodeDistrict($parametros)
    // {

    //     $queryBuilder = $this->connection->createQueryBuilder();
    //     $queryBuilder
    //         ->select([
    //             "CDBAIRRO",
    //             "NMBAIRRO",
    //             "NMBAIRRO AS NMBAIRROENDERECO",
    //             "SGESTADO"
    //         ])
    //         ->from('BAIRRO')
    //         ->where(
    //             $queryBuilder->expr()->and(
    //                 $queryBuilder->expr()->like('NMBAIRRO', ':NMBAIRRO'),
    //                 $queryBuilder->expr()->eq('SGESTADO', ':SGESTADO'),
    //                 $queryBuilder->expr()->eq('CDPAIS', ':CDPAIS'),
    //                 $queryBuilder->expr()->eq('CDMUNICIPIO', ':CDMUNICIPIO'),
    //                 $queryBuilder->expr()->eq('IDATIVO', ':IDATIVO')
    //             )
    //         );

    //     $queryBuilder->setParameter('NMBAIRRO', $parametros["NMBAIRRO"]);
    //     $queryBuilder->setParameter('SGESTADO', $parametros["SGESTADO"]);
    //     $queryBuilder->setParameter('CDPAIS', $parametros["CDPAIS"]);
    //     $queryBuilder->setParameter('CDMUNICIPIO', $parametros["CDMUNICIPIO"]);
    //     $queryBuilder->setParameter('IDATIVO', 'S');

    //     $result = $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $queryBuilder->getSQL(), $queryBuilder->getParameters());
    //     return $result;
    // }

//     public function findCodeDistrict($parametros)
// {
//     $queryBuilder = $this->connection->createQueryBuilder();

//     $queryBuilder
//         ->select([
//             "CDBAIRRO",
//             "NMBAIRRO",
//             // "NMBAIRRO AS NMBAIRROENDERECO",
//             "SGESTADO"
//         ])
//         ->from('BAIRRO')
//         ->where(
//             $queryBuilder->expr()->and(
//                 $queryBuilder->expr()->like('NMBAIRRO', ':NMBAIRRO'),
//                 $queryBuilder->expr()->eq('SGESTADO', ':SGESTADO'),
//                 $queryBuilder->expr()->eq('CDPAIS', ':CDPAIS'),
//                 $queryBuilder->expr()->eq('CDMUNICIPIO', ':CDMUNICIPIO'),
//                 $queryBuilder->expr()->eq('IDATIVO', ':IDATIVO')
//             )
//         );

//     // Usando o operador de coalescência nula para valores padrão
//     // $queryBuilder->setParameter('NMBAIRRO', $parametros['NMBAIRRO'] ?? '');
//     $queryBuilder->setParameter('SGESTADO', $parametros['SGESTADO'] ?? '');
//     $queryBuilder->setParameter('CDPAIS', $parametros['CDPAIS'] ?? '');
//     $queryBuilder->setParameter('CDMUNICIPIO', $parametros['CDMUNICIPIO'] ?? '');
//     $queryBuilder->setParameter('IDATIVO', $parametros['IDATIVO'] ?? 'S');

//     $result = $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $queryBuilder->getSQL(), $queryBuilder->getParameters());
//     // var_dump($result);
//     return $result;
// }

public function findCodeDistrict($parametros)
{
    $queryBuilder = $this->connection->createQueryBuilder();

    $queryBuilder
        ->select([
            "CDBAIRRO",
            "NMBAIRRO",
            "SGESTADO"
        ])
        ->from('BAIRRO')
        ->where(
            $queryBuilder->expr()->and(
                $queryBuilder->expr()->like('NMBAIRRO', ':NMBAIRRO'),
                $queryBuilder->expr()->eq('SGESTADO', ':SGESTADO'),
                $queryBuilder->expr()->eq('CDPAIS', ':CDPAIS'),
                $queryBuilder->expr()->eq('CDMUNICIPIO', ':CDMUNICIPIO'),
                $queryBuilder->expr()->eq('IDATIVO', ':IDATIVO')
            )
        );

    // Definição correta dos parâmetros
    $queryBuilder->setParameter('NMBAIRRO', isset($parametros['NMBAIRRO']) ? "%{$parametros['NMBAIRRO']}%" : '%');
    $queryBuilder->setParameter('SGESTADO', $parametros['SGESTADO'] ?? '');
    $queryBuilder->setParameter('CDPAIS', $parametros['CDPAIS'] ?? '');
    $queryBuilder->setParameter('CDMUNICIPIO', $parametros['CDMUNICIPIO'] ?? '');
    $queryBuilder->setParameter('IDATIVO', $parametros['IDATIVO'] ?? 'S');

    $result = $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $queryBuilder->getSQL(), $queryBuilder->getParameters());

    return $result;
}


    public function findBairro($params)
    {
        $sql = "SELECT
                    CDBAIRRO,
                    NMBAIRRO,
                    SGESTADO,
                    CDPAIS
                FROM
                    BAIRRO
                    WHERE IDATIVO = 'S'
                        AND SGESTADO = :SGESTADO
                        AND CDPAIS = :CDPAIS
                        AND CDMUNICIPIO = :CDMUNICIPIO";
                
                return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);        
    }
}
