<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm_00024_000_tab_tipos_Operacoes_DespesasFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function gettpoperdespdiv()
    {

        $sql = "SELECT
                    DIV.IDATIVO as IDATIVO,
                    DIV.CDOPERULTATU as CDOPERULTATU,
                    DIV.NRORGULTATU as NRORGULTATU,
                    DIV.CDOPERINCLUSAO as CDOPERINCLUSAO,
                    DIV.NRORGINCLUSAO as NRORGINCLUSAO,
                    DIV.DTULTATU as DTULTATU,
                    DIV.DTINCLUSAO as DTINCLUSAO,
                    DIV.NRORG as NRORG,
                    DIV.IDENTRSAIDOP as IDENTRSAIDOP,
                    DIV.CDTIPOOPER as CDTIPOOPER,
                    DIV.NRTPOPERDESPDIV as NRTPOPERDESPDIV,
                    TIP.NMTIPOOPER as NMTIPOOPER
                FROM FCT_TPOPERDESPDIV DIV
                    INNER JOIN TIPOOPERAC TIP ON DIV.CDTIPOOPER = TIP.CDTIPOOPER";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function gettipooperac()
    {

        $sql = "SELECT
                    TIP.CDTIPOOPER as CDTIPOOPER,
                    TIP.NMTIPOOPER as NMTIPOOPER,
                    TIP.IDENTRSAIDOP as IDENTRSAIDOP,
                    TIP.NRORG as NRORG
                FROM
                    TIPOOPERAC TIP";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function adicionar_tip_oper_desp($params)
    {
        $sql = "INSERT INTO FCT_TPOPERDESPDIV (
                NRTPOPERDESPDIV, CDTIPOOPER, IDENTRSAIDOP, 
                NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, 
                CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO 
                )
                VALUES (
                    :NRTPOPERDESPDIV, :CDTIPOOPER, :IDENTRSAIDOP, :NRORG, SYSDATE, 
                    SYSDATE, :NRORG, :CDOPERINCLUSAO, :NRORG, :CDOPERINCLUSAO, 'S'
                    )";

        $this->connection->executeStatement($sql, $params);
    }

    public function excluir_tip_oper_desp($parametro)
    {
        $sql = "DELETE FROM FCT_TPOPERDESPDIV
        WHERE NRTPOPERDESPDIV IN (".$parametro.")";

        $this->connection->executeStatement($sql);
    }

    public function verificarItemRepetido($params)
    {
        $sql = "SELECT COUNT(*) AS EXISTE
                    FROM FCT_TPOPERDESPDIV
                WHERE CDTIPOOPER = :CDTIPOOPER";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

}
