import {
    Button, Modal, ModalService, Select, TextInput, Text, LoadingService, Form, DialogService, Footer, Tabs, Number as NumberInput, Textarea,
    SelectMultiple,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';
import { Http, IDictionary, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class Sm00029000LocalAtendimentoController {
    public tekgridLocalAtendimentoVisivel: boolean = true;

    public currentRow: any = {};

    private basicModal!: Modal;

    get formLocalAtendimentoVisivel() {
        return !this.tekgridLocalAtendimentoVisivel;
    }

    public voltarTekGridLocalAtendimento() {
        this.tekgridLocalAtendimentoVisivel = true;
    }

    get textFrameLocalAtendimento() {
        return this.currentRow.NMESTRUTURAM;
    }

    public abrirFrameLocalAtendimento({ row }: any) {
        this.tekgridLocalAtendimentoVisivel = false;
        this.currentRow = row;
        const tabs = Metadata.getInstance<Tabs>('tabsInformationLocalAtendimento');
        this.carregarTabsLocalAtendimento({ component: tabs });
    }

    public carregarTabsLocalAtendimento({ component }: any) {
        const tabAtiva = component.activeTab;
        const footer = Metadata.getInstance<Footer>('exampleFooterTabLocalAtendimento');

        if (component.tabs[tabAtiva].name === 'tab_LocalAtendimento') {
            this.onFilterbairroPrincipal();
            this.onFilterbairroCobranca();
            this.onFilterbairroExterior();
            this.onFilterbairroEntrega();
            this.carregarDadosAbaLocalAtendimento();
            footer.isVisible = true;
        }
    }

    public onFilterbairroPrincipal() {
        const bairroPrincipal = Metadata.getInstance<Select>('formTabLocalAtendimento-NMBAIRROENDERECO');
        bairroPrincipal.datasource.setFilter({
            NRPARCNEGOCIO: this.currentRow.NRPARCNEGOCIO,
        });
    }

    public onFilterbairroCobranca() {
        const bairroCobranca = Metadata.getInstance<Select>('formTabLocalAtendimento-NMBAIRROENDERECO_COBRANCA');
        bairroCobranca.datasource.setFilter({
            NRPARCNEGOCIO: this.currentRow.NRPARCNEGOCIO,
        });
    }

    public onFilterbairroExterior() {
        const bairroExterior = Metadata.getInstance<Select>('formTabLocalAtendimento-NMBAIRROENDERECO_EXTERIOR');
        bairroExterior.datasource.setFilter({
            NRPARCNEGOCIO: this.currentRow.NRPARCNEGOCIO,
        });
    }

    public onFilterbairroEntrega() {
        const bairroEntrega = Metadata.getInstance<Select>('formTabLocalAtendimento-NMBAIRROENDERECO_ENTREGA');
        bairroEntrega.datasource.setFilter({
            NRPARCNEGOCIO: this.currentRow.NRPARCNEGOCIO,
        });
    }

    public carregarDadosAbaLocalAtendimento() {
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-NMESTRUTURAM').value = this.currentRow.NMESTRUTURAM;
        Metadata.getInstance<Select>('formTabLocalAtendimento-IDCONVERTIDOCLIENTE').value = this.currentRow.IDCONVERTIDOCLIENTE;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-IDCRIANOVOCLIENTE').value = this.currentRow.IDCRIANOVOCLIENTE;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDCLIENTE').value = this.currentRow.CDCLIENTE;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-NRINSCRICAOPARC').value = this.currentRow.NRINSCRICAOPARC;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDTIPOINSCRICAO').value = this.currentRow.CDTIPOINSCRICAO;
        Metadata.getInstance<Select>('formTabLocalAtendimento-NRTIPOESTRUTURA').value = this.currentRow.NRTIPOESTRUTURA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-NRESTRUTURAMSUP').value = this.currentRow.NRESTRUTURAMSUP;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDCENTCUST').value = this.currentRow.CDCENTCUST;
        Metadata.getInstance<Select>('formTabLocalAtendimento-IDCONVERTIDOFILIAL').value = this.currentRow.IDCONVERTIDOFILIAL;
        Metadata.getInstance<Select>('formTabLocalAtendimento-IDCRIANOVAUNIDADE').value = this.currentRow.IDCRIANOVAUNIDADE;
        Metadata.getInstance<Select>('formTabLocalAtendimento-NMFILIAL').value = this.currentRow.NMFILIAL;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-CDFILIAL').value = this.currentRow.CDFILIAL;
        Metadata.getInstance<Select>('formTabLocalAtendimento-NMEMPRESA').value = this.currentRow.CDEMPRESA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDEMPRESA').value = this.currentRow.CDEMPRESA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDINSCMUNI').value = this.currentRow.CDEMPRESA;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-NMRAZSOCFILI').value = this.currentRow.NMRAZSOCFILI;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-NRCEPENDERECO').value = this.currentRow.NRCEPENDERECO;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDPAIS').value = this.currentRow.CDPAIS;
        Metadata.getInstance<Select>('formTabLocalAtendimento-SGESTADO').value = this.currentRow.SGESTADO;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDMUNICIPIO').value = this.currentRow.CDMUNICIPIO;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-DSENDERECO').value = this.currentRow.DSENDERECO;
        Metadata.getInstance<NumberInput>('formTabLocalAtendimento-NRIMOVELENDERECO').value = this.currentRow.NRIMOVELENDERECO;
        Metadata.getInstance<Select>('formTabLocalAtendimento-NMBAIRROENDERECO').value = this.currentRow.NMBAIRRO;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-DSCOMPLEENDERECO').value = this.currentRow.DSCOMPLEENDERECO;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-DSEMAILESTRUTURA').value = this.currentRow.DSEMAILESTRUTURA;
        Metadata.getInstance<Textarea>('formTabLocalAtendimento-DSREFERENCIAENDE').value = this.currentRow.DSREFERENCIAENDE;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-NRCEPENDERECO_COBRANCA').value = this.currentRow.NRCEPENDERECO_COBRANCA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDPAIS_COBRANCA').value = this.currentRow.CDPAIS_COBRANCA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-SGESTADO_COBRANCA').value = this.currentRow.SGESTADO_COBRANCA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDMUNICIPIO_COBRANCA').value = this.currentRow.CDMUNICIPIO_COBRANCA;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-DSENDERECO_COBRANCA').value = this.currentRow.DSENDERECO_COBRANCA;
        Metadata.getInstance<NumberInput>('formTabLocalAtendimento-NRIMOVELENDERECO_COBRANCA').value = this.currentRow.NRIMOVELENDERECO_COBRANCA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-NMBAIRROENDERECO_COBRANCA').value = this.currentRow.NMBAIRROENDERECO_COBRANCA;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-DSCOMPLEENDERECO_COBRANCA').value = this.currentRow.DSCOMPLEENDERECO_COBRANCA;
        Metadata.getInstance<Textarea>('formTabLocalAtendimento-DSREFERENCIAENDE_COBRANCA').value = this.currentRow.DSREFERENCIAENDE_COBRANCA;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-NRCEPENDERECO_EXTERIOR').value = this.currentRow.NRCEPENDERECO_EXTERIOR;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDPAIS_EXTERIOR').value = this.currentRow.CDPAIS_EXTERIOR;
        Metadata.getInstance<Select>('formTabLocalAtendimento-SGESTADO_EXTERIOR').value = this.currentRow.SGESTADO_EXTERIOR;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDMUNICIPIO_EXTERIOR').value = this.currentRow.CDMUNICIPIO_EXTERIOR;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-DSENDERECO_EXTERIOR').value = this.currentRow.DSENDERECO_EXTERIOR;
        Metadata.getInstance<NumberInput>('formTabLocalAtendimento-NRIMOVELENDERECO_EXTERIOR').value = this.currentRow.NRIMOVELENDERECO_EXTERIOR;
        Metadata.getInstance<Select>('formTabLocalAtendimento-NMBAIRROENDERECO_EXTERIOR').value = this.currentRow.NMBAIRROENDERECO_EXTERIOR;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-DSCOMPLEENDERECO_EXTERIOR').value = this.currentRow.DSCOMPLEENDERECO_EXTERIOR;
        Metadata.getInstance<Textarea>('formTabLocalAtendimento-DSREFERENCIAENDE_EXTERIOR').value = this.currentRow.DSREFERENCIAENDE_EXTERIOR;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-NRCEPENDERECO_ENTREGA').value = this.currentRow.NRCEPENDERECO_ENTREGA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDPAIS_ENTREGA').value = this.currentRow.CDPAIS_ENTREGA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-SGESTADO_ENTREGA').value = this.currentRow.SGESTADO_ENTREGA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-CDMUNICIPIO_ENTREGA').value = this.currentRow.CDMUNICIPIO_ENTREGA;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-DSENDERECO_ENTREGA').value = this.currentRow.DSENDERECO_ENTREGA;
        Metadata.getInstance<NumberInput>('formTabLocalAtendimento-NRIMOVELENDERECO_ENTREGA').value = this.currentRow.NRIMOVELENDERECO_ENTREGA;
        Metadata.getInstance<Select>('formTabLocalAtendimento-NMBAIRROENDERECO_ENTREGA').value = this.currentRow.NMBAIRROENDERECO_ENTREGA;
        Metadata.getInstance<TextInput>('formTabLocalAtendimento-DSCOMPLEENDERECO_ENTREGA').value = this.currentRow.DSCOMPLEENDERECO_ENTREGA;
        Metadata.getInstance<Textarea>('formTabLocalAtendimento-DSREFERENCIAENDE_ENTREGA').value = this.currentRow.DSREFERENCIAENDE_ENTREGA;
    }

    public clienteNovo_Habilitado({ component }: any) {
        const IDCRIANOVOCLIENTE = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-IDCRIANOVOCLIENTE`);
        IDCRIANOVOCLIENTE.readonly = false;
        IDCRIANOVOCLIENTE.addValidation('required', {});
    }

    public clienteNovo_Desabilitado({ component }: any) {
        const IDCRIANOVOCLIENTE = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-IDCRIANOVOCLIENTE`);
        IDCRIANOVOCLIENTE.readonly = true;
        IDCRIANOVOCLIENTE.removeValidation('required');
    }

    public inscricao_Habilitado({ component }: any) {
        const NRINSCRICAOPARC = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NRINSCRICAOPARC`);
        NRINSCRICAOPARC.readonly = false;
        NRINSCRICAOPARC.addValidation('required', {});
    }

    public inscricao_Desabilitado({ component }: any) {
        const NRINSCRICAOPARC = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NRINSCRICAOPARC`);
        NRINSCRICAOPARC.readonly = true;
        NRINSCRICAOPARC.removeValidation('required');
    }

    public cliente_Habilitado({ component }: any) {
        const CDCLIENTE = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDCLIENTE`);
        CDCLIENTE.readonly = false;
        CDCLIENTE.addValidation('required', {});
    }

    public cliente_Desabilitado({ component }: any) {
        const CDCLIENTE = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDCLIENTE`);
        CDCLIENTE.readonly = true;
        CDCLIENTE.removeValidation('required');
    }

    public tipoInscricao_Habilitado({ component }: any) {
        const CDTIPOINSCRICAO = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDTIPOINSCRICAO`);
        CDTIPOINSCRICAO.readonly = false;
    }

    public tipoInscricao_Desabilitado({ component }: any) {
        const CDTIPOINSCRICAO = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDTIPOINSCRICAO`);
        CDTIPOINSCRICAO.readonly = true;
    }

    public onChangeFieldInserirConvertido_Em_Cliente({ component }: any) {
        const IDCONVERTIDOCLIENTE = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-IDCONVERTIDOCLIENTE`);
        const IDCRIANOVOCLIENTE = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-IDCRIANOVOCLIENTE`);

        if (IDCRIANOVOCLIENTE.value === undefined) {
            IDCRIANOVOCLIENTE.value = null;
        }
        // if (IDCRIANOVOCLIENTE.value === null) {
        //     IDCRIANOVOCLIENTE.value = '';
        // }
        if (IDCONVERTIDOCLIENTE.value === 'S') {
            this.clienteNovo_Habilitado({ component });
            this.cliente_Habilitado({ component });
            this.inscricao_Desabilitado({ component });
            this.tipoInscricao_Desabilitado({ component });
            if (IDCRIANOVOCLIENTE.value === 'S') {
                this.clienteNovo_Habilitado({ component });
                this.inscricao_Habilitado({ component });
                this.cliente_Desabilitado({ component });
                this.tipoInscricao_Desabilitado({ component });
            } else if (IDCRIANOVOCLIENTE.value === 'N') {
                this.clienteNovo_Habilitado({ component });
                this.inscricao_Desabilitado({ component });
                this.cliente_Habilitado({ component });
                this.tipoInscricao_Desabilitado({ component });
            }
        } else if (IDCONVERTIDOCLIENTE.value === 'N') {
            this.clienteNovo_Desabilitado({ component });
            this.inscricao_Desabilitado({ component });
            this.cliente_Desabilitado({ component });
            this.tipoInscricao_Desabilitado({ component });
        }
    }

    public vincularUnidade_Habilitado({ component }: any) {
        const IDCRIANOVAUNIDADE = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-IDCRIANOVAUNIDADE`);
        IDCRIANOVAUNIDADE.readonly = false;
        IDCRIANOVAUNIDADE.addValidation('required');
    }

    public vincularUnidade_Desabilitado({ component }: any) {
        const IDCRIANOVAUNIDADE = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-IDCRIANOVAUNIDADE`);
        IDCRIANOVAUNIDADE.readonly = true;
        IDCRIANOVAUNIDADE.removeValidation('required');
    }

    public unidade_Habilitado({ component }: any) {
        const NMFILIAL = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMFILIAL`);
        NMFILIAL.readonly = false;
        NMFILIAL.addValidation('required');
    }

    public unidade_Desabilitado({ component }: any) {
        const NMFILIAL = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMFILIAL`);
        NMFILIAL.readonly = true;
        NMFILIAL.removeValidation('required');
    }

    public codigoUnidade_Habilitado({ component }: any) {
        const CDFILIAL = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-CDFILIAL`);
        CDFILIAL.readonly = false;
        // CDFILIAL.addValidation('required');
    }

    public codigoUnidade_Habilitado_Validando({ component }: any) {
        const CDFILIAL = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-CDFILIAL`);
        CDFILIAL.readonly = false;
        CDFILIAL.addValidation('required');
    }

    public codigoUnidade_Desabilitado({ component }: any) {
        const CDFILIAL = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-CDFILIAL`);
        CDFILIAL.readonly = true;
        // CDFILIAL.removeValidation('required');
    }

    public codigoUnidade_Desabilitado_N_Validando({ component }: any) {
        const CDFILIAL = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-CDFILIAL`);
        CDFILIAL.readonly = true;
        CDFILIAL.removeValidation('required');
    }

    public empresa_Habilitado({ component }: any) {
        const NMEMPRESA = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMEMPRESA`);
        NMEMPRESA.readonly = false;
        // NMEMPRESA.addValidation('required');
    }

    public empresa_Habilitado_Validando({ component }: any) {
        const NMEMPRESA = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMEMPRESA`);
        NMEMPRESA.readonly = false;
        NMEMPRESA.addValidation('required');
    }

    public empresa_Desabilitado({ component }: any) {
        const NMEMPRESA = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMEMPRESA`);
        NMEMPRESA.readonly = true;
        // NMEMPRESA.removeValidation('required');
    }

    public empresa_Desabilitado_N_Validando({ component }: any) {
        const NMEMPRESA = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMEMPRESA`);
        NMEMPRESA.readonly = true;
        NMEMPRESA.removeValidation('required');
    }

    public inscrEstadual_Habilitado({ component }: any) {
        const CDINSCESTA = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDEMPRESA`);
        CDINSCESTA.readonly = false;
        // CDINSCESTA.addValidation('required');
    }

    public inscrEstadual_Habilitado_Validando({ component }: any) {
        const CDINSCESTA = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDEMPRESA`);
        CDINSCESTA.readonly = false;
        CDINSCESTA.addValidation('required');
    }

    public inscrEstadual_Desabilitado({ component }: any) {
        const CDINSCESTA = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDEMPRESA`);
        CDINSCESTA.readonly = true;
        // CDINSCESTA.removeValidation('required');
    }

    public inscrEstadual_Desabilitado_N_Validando({ component }: any) {
        const CDINSCESTA = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDEMPRESA`);
        CDINSCESTA.readonly = true;
        CDINSCESTA.removeValidation('required');
    }

    public inscrMunicipal_Habilitado({ component }: any) {
        const CDINSCMUNI = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDINSCMUNI`);
        CDINSCMUNI.readonly = false;
        // CDINSCMUNI.addValidation('required');
    }

    public inscrMunicipal_Habilitado_Validando({ component }: any) {
        const CDINSCMUNI = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDINSCMUNI`);
        CDINSCMUNI.readonly = false;
        CDINSCMUNI.addValidation('required');
    }

    public inscrMunicipal_Desabilitado({ component }: any) {
        const CDINSCMUNI = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDINSCMUNI`);
        CDINSCMUNI.readonly = true;
        // CDINSCMUNI.removeValidation('required');
    }

    public inscrMunicipal_Desabilitado_N_Validando({ component }: any) {
        const CDINSCMUNI = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDINSCMUNI`);
        CDINSCMUNI.readonly = true;
        CDINSCMUNI.removeValidation('required');
    }

    public razaoSocial_Habilitado({ component }: any) {
        const NMRAZSOCFILI = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NMRAZSOCFILI`);
        NMRAZSOCFILI.readonly = false;
        // NMRAZSOCFILI.addValidation('required');
    }

    public razaoSocial_Habilitado_Validando({ component }: any) {
        const NMRAZSOCFILI = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NMRAZSOCFILI`);
        NMRAZSOCFILI.readonly = false;
        NMRAZSOCFILI.addValidation('required');
    }

    public razaoSocial_Desabilitado({ component }: any) {
        const NMRAZSOCFILI = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NMRAZSOCFILI`);
        NMRAZSOCFILI.readonly = true;
        // NMRAZSOCFILI.removeValidation('required');
    }

    public razaoSocial_Desabilitado_N_Validando({ component }: any) {
        const NMRAZSOCFILI = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NMRAZSOCFILI`);
        NMRAZSOCFILI.readonly = true;
        NMRAZSOCFILI.removeValidation('required');
    }

    public cep_End_Principal_Habilitado_Validando({ component }: any) {
        const NRCEPENDERECO = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NRCEPENDERECO`);
        NRCEPENDERECO.readonly = false;
        NRCEPENDERECO.addValidation('required');
    }

    public cep_End_Principal_Habilitado_N_Validando({ component }: any) {
        const NRCEPENDERECO = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NRCEPENDERECO`);
        NRCEPENDERECO.readonly = false;
        NRCEPENDERECO.removeValidation('required');
    }

    public cep_End_Principal_Desabilitado_N_Validando({ component }: any) {
        const NRCEPENDERECO = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NRCEPENDERECO`);
        NRCEPENDERECO.readonly = true;
        NRCEPENDERECO.removeValidation('required');
    }

    public enderecoPrincipal_Habilitado_Validando({ component }: any) {
        const DSENDERECO = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-DSENDERECO`);
        DSENDERECO.readonly = false;
        DSENDERECO.addValidation('required');
    }

    public enderecoPrincipal_Habilitado_N_Validando({ component }: any) {
        const DSENDERECO = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-DSENDERECO`);
        DSENDERECO.readonly = false;
        DSENDERECO.removeValidation('required');
    }

    public enderecoPrincipal_Desabilitado_N_Validando({ component }: any) {
        const DSENDERECO = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-DSENDERECO`);
        DSENDERECO.readonly = true;
        DSENDERECO.removeValidation('required');
    }

    public numeroEnderecoPrincipal_Habilitado_Validando({ component }: any) {
        const NRIMOVELENDERECO = Metadata.getInstance<NumberInput>(`${component.name.split('-')[0]}-NRIMOVELENDERECO`);
        NRIMOVELENDERECO.readonly = false;
        NRIMOVELENDERECO.addValidation('required');
    }

    public numeroEnderecoPrincipal_Habilitado_N_Validando({ component }: any) {
        const NRIMOVELENDERECO = Metadata.getInstance<NumberInput>(`${component.name.split('-')[0]}-NRIMOVELENDERECO`);
        NRIMOVELENDERECO.readonly = false;
        NRIMOVELENDERECO.removeValidation('required');
    }

    public numeroEnderecoPrincipal_Desabilitado_N_Validando({ component }: any) {
        const NRIMOVELENDERECO = Metadata.getInstance<NumberInput>(`${component.name.split('-')[0]}-NRIMOVELENDERECO`);
        NRIMOVELENDERECO.readonly = true;
        NRIMOVELENDERECO.removeValidation('required');
    }

    public bairroEnderecoPrincipal_Habilitado_Validando({ component }: any) {
        const NMBAIRROENDERECO = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO`);
        NMBAIRROENDERECO.readonly = false;
        NMBAIRROENDERECO.addValidation('required');
    }

    public bairroEnderecoPrincipal_Habilitado_N_Validando({ component }: any) {
        const NMBAIRROENDERECO = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO`);
        NMBAIRROENDERECO.readonly = false;
        NMBAIRROENDERECO.removeValidation('required');
    }

    public bairroEnderecoPrincipal_Desabilitado_N_Validando({ component }: any) {
        const NMBAIRROENDERECO = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO`);
        NMBAIRROENDERECO.readonly = true;
        NMBAIRROENDERECO.removeValidation('required');
    }

    public onChangeFieldInserirDadosDaUnidade({ component }: any) {
        const IDCONVERTIDOFILIAL = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-IDCONVERTIDOFILIAL`);

        if (IDCONVERTIDOFILIAL?.value === undefined) {
            IDCONVERTIDOFILIAL.value = 'N';
        }

        // if (IDCONVERTIDOFILIAL.value === null) {
        //     IDCONVERTIDOFILIAL.value = '';
        // }

        if (IDCONVERTIDOFILIAL?.value === 'N') {
            this.vincularUnidade_Desabilitado({ component });
            this.unidade_Desabilitado({ component });
            this.codigoUnidade_Desabilitado({ component });
            this.empresa_Desabilitado({ component });
            this.inscrEstadual_Desabilitado({ component });
            this.inscrMunicipal_Desabilitado({ component });
            this.razaoSocial_Desabilitado({ component });
        } else if (IDCONVERTIDOFILIAL?.value === 'S') {
            this.vincularUnidade_Habilitado({ component });
            this.unidade_Habilitado({ component });
            this.codigoUnidade_Desabilitado({ component });
            this.empresa_Desabilitado({ component });
            this.inscrEstadual_Desabilitado({ component });
            this.inscrMunicipal_Desabilitado({ component });
            this.razaoSocial_Desabilitado({ component });
        }
    }

    public onChangeFieldCriar_Uma_Nova_Unidade({ component }: any) {
        const IDCRIANOVAUNIDADE = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-IDCRIANOVAUNIDADE`);
        const IDCONVERTIDOFILIAL = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-IDCONVERTIDOFILIAL`);

        if (IDCONVERTIDOFILIAL?.value === 'S') {
            if (IDCRIANOVAUNIDADE?.value === 'S') {
                this.inscricao_Habilitado({ component });
                this.unidade_Desabilitado({ component });
                this.codigoUnidade_Habilitado_Validando({ component });
                this.empresa_Habilitado_Validando({ component });
                this.inscrEstadual_Habilitado_Validando({ component });
                this.inscrMunicipal_Habilitado_Validando({ component });
                this.razaoSocial_Habilitado_Validando({ component });
                this.cep_End_Principal_Habilitado_Validando({ component });
                this.enderecoPrincipal_Habilitado_Validando({ component });
                this.numeroEnderecoPrincipal_Habilitado_Validando({ component });
                this.bairroEnderecoPrincipal_Habilitado_Validando({ component });
            } else if (IDCRIANOVAUNIDADE?.value === 'N') {
                this.inscricao_Desabilitado({ component });
                this.unidade_Habilitado({ component });
                this.codigoUnidade_Desabilitado_N_Validando({ component });
                this.empresa_Desabilitado_N_Validando({ component });
                this.inscrEstadual_Desabilitado_N_Validando({ component });
                this.inscrMunicipal_Desabilitado_N_Validando({ component });
                this.razaoSocial_Desabilitado_N_Validando({ component });
                this.cep_End_Principal_Habilitado_N_Validando({ component });
                this.enderecoPrincipal_Habilitado_N_Validando({ component });
                this.numeroEnderecoPrincipal_Habilitado_N_Validando({ component });
                this.bairroEnderecoPrincipal_Habilitado_N_Validando({ component });
            }
        }
    }

    public openFilterLocalAtendimento({ component }: any) {
        const filterButton = Metadata.getInstance<Button>(`${component.name}_filterButton`);
        filterButton.click({} as Event, {} as HTMLElement);
    }

    public fecharModalInsercaoLocalAtendimento() {
        this.basicModal.hide();
        this.basicModal?.destroy();
    }

    public async abrirModalInsercaoLocalAtendimento() {
        await this.exibirModalInsercaoLocalAtendimento();
        Metadata.getInstance<Text>('titleText').text = 'Novo Local de Atendimento';
    }

    public async exibirModalInsercaoLocalAtendimento() {
        this.basicModal = await ModalService.createFromJson('sm_00029_000_local_atendimento/modal/sm_00029_000_insercao_local_atendimento', true);
        this.basicModal.show();
    }

    public setFilterCamposModalInsert({ component }: any) {
        const nmestruturam = this.currentRow.NMESTRUTURAM;
        try {
            component.datasource.setFilter({
                NMESTRUTURAM: nmestruturam,
            });
        } catch (e) {
            console.error(e);
        }
    }

    public setModalInsertLocalAtendimento({ component }: any) {
        const nrseqcontrato = component.value;
        component.datasource.data.forEach((dados: any) => {
            if (dados.NRSEQCONTRATO === nrseqcontrato || nrseqcontrato !== null) {
                Metadata.getInstance<Select>('formTabModalLocalAtendimento-IDCONVERTIDOCLIENTE').value = dados.IDCONVERTIDOCLIENTE;
                const textSituacao = dados.IDCRIANOVOCLIENTE;
                switch (textSituacao) {
                    case 'S':
                        Metadata.getInstance<TextInput>('formTabModalLocalAtendimento-IDCRIANOVOCLIENTE').value = 'Pendente';
                        break;
                    case 'N':
                        Metadata.getInstance<TextInput>('formTabModalLocalAtendimento-IDCRIANOVOCLIENTE').value = 'Aprovado';
                        break;
                    default:
                        break;
                }
            } else {
                Metadata.getInstance<Select>('formTabModalLocalAtendimento-IDCONVERTIDOCLIENTE').value = null;
                Metadata.getInstance<TextInput>('formTabModalLocalAtendimento-IDCRIANOVOCLIENTE').value = null;
                Metadata.getInstance<Select>('formTabModalLocalAtendimento-CDTIPOINSCRICAO').value = null;
            }
        });
    }

    public salvarLocalAtendimento() {
        const formContrato = Metadata.getInstance<Form>('formTabModalLocalAtendimento');
        const formDocumento = Metadata.getInstance<Form>('formDadosDocumentoModalContrato');
        const grid = Metadata.getInstance<TekGrid>('tek-grid-local_atendimento_grid');
        const params = {
            NRSEQCONTRATO: Metadata.getInstance<Select>('formTabModalLocalAtendimento-NMESTRUTURAM').value,
            IDPADRAO: Metadata.getInstance<Select>('formDadosDocumentoModalContrato-IDPADRAO').value,
            VRTAMANHOLOGO: Metadata.getInstance<TextInput>('formDadosDocumentoModalContrato-VRTAMANHOLOGO').value,
            IDSITUACAOCONTRATO: Metadata.getInstance<Select>('formDadosDocumentoModalContrato-IDSITUACAOCONTRATO').value,
            DSMODELODOCORCA: Metadata.getInstance<Select>('formDadosDocumentoModalContrato-DSMODELODOCORCA').value,
        };
        if (Utilities.validateForm(formContrato) && Utilities.validateForm(formDocumento)) {
            LoadingService.show();
            Http.post('/inserirLocalAtendimento', params).then(() => {
                this.fecharModalInsercaoLocalAtendimento();
                grid.datasource.get();
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public showConfirmDeleteMessage({ event }: any) {
        event!.preventDefault();
        DialogService.show({
            name: 'buttons-dialog-local-atendimento',
            type: 'warning',
            title: 'Excluir Registro',
            text: 'Deseja realmente excluir todos os registros selecionados?',
            buttons: [
                {
                    name: 'NAO',
                    component: 'ZdButton',
                    label: 'Não',
                    outline: true,
                    events: {
                        click: () => {
                            DialogService.hide();
                        },
                    },
                },
                {
                    name: 'SIM',
                    component: 'ZdButton',
                    label: 'Sim',
                    events: {
                        click: () => {
                            this.deleteLocalAtendimento();
                            DialogService.hide();
                        },
                    },
                },
            ],
        });
    }

    public deleteLocalAtendimento() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-local_atendimento_grid');
        LoadingService.show();
        Http.post('/deleteLocalAtendimento', grid.selectedRows)
            .then(() => {
                grid.selectedRows = [];
                grid.reload();
                Utilities.showSuccessMessage();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }

    // private getFilterInputs(field: string): any {
    //     return this.getGridInstance().getFilterInputs(field);
    // }

    // private getGridInstance() {
    //     return Metadata.getInstance<TekGrid>('tek-grid-local_atendimento_grid');
    // }

    public showDialogWithButtonsGrid({ component }: any) {
        if (component.value.length === 8) {
            setTimeout(() => {
                DialogService.show({
                    name: 'dialog-find-partner-addres',
                    type: 'warning',
                    title: 'Buscar Endereço',
                    text: 'Deseja buscar o endereço pelo CEP?',
                    buttons: [
                        {
                            name: 'NAO',
                            component: 'ZdButton',
                            label: 'Não',
                            outline: true,
                            events: {
                                click: () => {
                                    DialogService.hide();
                                },
                            },
                        },
                        {
                            name: 'SIM',
                            component: 'ZdButton',
                            label: 'Sim',
                            events: {
                                click: () => {
                                    this.validateCEP({ component });
                                    DialogService.hide();
                                },
                            },
                        },
                    ],
                });
            }, 100); // Pequeno atraso para garantir que o SDK carregue
        }
    }

    public validate({ component }: any) {
        this.validateCEP(`${component.name.split('-')[0]}-NRCEPENDERECO`);
    }

    public async validateCEP({ component }: any) {
        const CEP = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NRCEPENDERECO`).value.replace('-', '');
        if (CEP.length !== 8) {
            return;
        }

        LoadingService.show();
        try {
            const response = await this.searchCep(CEP) as IDictionary;
            const addressFound = response.data.dataset.ENDERECO;

            if (!addressFound) {
                return;
            }

            // Limpar campos de endereço antes de preencher com novos dados
            this.clearAddressFields({ component });

            Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-DSENDERECO`).value = addressFound.DSENDERECO;
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS`).setValue(addressFound.CDPAIS ?? '');
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO`).setValue(addressFound.SGESTADO ?? '');
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO`).setValue(addressFound.CDMUNICIPIO ?? '');

            // Se o código do bairro estiver vazio, busca e preenche
            if (!addressFound.CDBAIRRO) {
                await this.fetchAndSetBairroCode({ component }, addressFound);
            }
        } catch (error) {
            Utilities.showErrorMessage(error);
        } finally {
            LoadingService.hide();
        }
    }

    private async searchCep(cepValue: number): Promise<any | number> {
        if (String(cepValue).length === 8) {
            try {
                const response = await Http.post('/lib_findAddress', {
                    requestType: 'Row',
                    row: { CEP: cepValue },
                });
                return response;
            } catch (error) {
                console.error('Error searching for address:', error);
                return 0;
            }
        }
        return 0;
    }

    private clearAddressFields({ component }: any) {
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS`).setValue('');
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO`).setValue('');
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO`).setValue('');
    }

    private async fetchAndSetBairroCode({ component }: any, addressFound: IDictionary): Promise<void> {
        try {
            const bairroResponse = await Http.post('/findCodeDistrict', {
                NMBAIRRO: addressFound.NMBAIRRO,
                CDPAIS: addressFound.CDPAIS,
                SGESTADO: addressFound.SGESTADO,
                CDMUNICIPIO: addressFound.CDMUNICIPIO,
            });

            const bairroData = bairroResponse.data.data[0];
            const CDBAIRRO = bairroData ? bairroData.CDBAIRRO : '';
            // const SGESTADO = bairroData ? bairroData.SGESTADO : '';

            // const metadataInstance = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO`);
            Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO`).setValue({ CDBAIRRO });

            // Se setValue aceitar um objeto
            // metadataInstance.setValue({ CDBAIRRO, SGESTADO });
        } catch (error) {
            Utilities.showErrorMessage(error);
        }
    }

    public changeFieldState({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO`);
        const stateFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldState.name);

        if (component.value != null && component.name === statusFieldCountry.name) {
            stateFieldInstance.disabled = false;
            stateFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-CDPAIS`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO`);
            modalFieldState.disabled = false;
            modalFieldState.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
            });
        } else {
            stateFieldInstance.disabled = true;
            stateFieldInstance.value = null;
        }
    }

    public changeInTheMunicipalityField({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO`);
        const statusFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO`);

        const municipalityFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldMunicipality.name);

        if (component.value != null && component.name === statusFieldState.name) {
            municipalityFieldInstance.disabled = false;
            municipalityFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
                SGESTADO: statusFieldState.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-SGESTADO`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO`);
            const modalFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO`);
            modalFieldMunicipality.disabled = false;
            modalFieldMunicipality.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
                SGESTADO: modalFieldState.value,
            });
        } else {
            municipalityFieldInstance.disabled = true;
            municipalityFieldInstance.value = null;
        }
    }

    public changeInTheNeighborhoodField({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO`);
        const statusFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO`);
        const statusFieldNeighborhood = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO`);

        const neighborhoodFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldNeighborhood.name);

        if (component.value != null && component.name === statusFieldMunicipality.name) {
            neighborhoodFieldInstance.disabled = false;
            neighborhoodFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
                SGESTADO: statusFieldState.value,
                CDMUNICIPIO: statusFieldMunicipality.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-CDMUNICIPIO`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO`);
            const modalFieldNeighborhood = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO`);
            const modalFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO`);
            modalFieldNeighborhood.disabled = false;
            modalFieldNeighborhood.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
                SGESTADO: modalFieldState.value,
                CDMUNICIPIO: modalFieldMunicipality.value,
            });
        } else {
            neighborhoodFieldInstance.disabled = true;
            neighborhoodFieldInstance.value = null;
        }
    }

    // ABAIXO DADOS REFERENTE AO CEP DE COBRANCA
    public showDialogWithButtonsGridCobranca({ component }: any) {
        if (component.value.length === 8) {
            setTimeout(() => {
                DialogService.show({
                    name: 'dialog-find-partner-addres',
                    type: 'warning',
                    title: 'Buscar Endereço',
                    text: 'Deseja buscar o endereço pelo CEP?',
                    buttons: [
                        {
                            name: 'NAO',
                            component: 'ZdButton',
                            label: 'Não',
                            outline: true,
                            events: {
                                click: () => {
                                    DialogService.hide();
                                },
                            },
                        },
                        {
                            name: 'SIM',
                            component: 'ZdButton',
                            label: 'Sim',
                            events: {
                                click: () => {
                                    this.validateCEPCobranca({ component });
                                    DialogService.hide();
                                },
                            },
                        },
                    ],
                });
            }, 100); // Pequeno atraso para garantir que o SDK carregue
        }
    }

    public validateCobranca({ component }: any) {
        this.validateCEPCobranca(`${component.name.split('-')[0]}-NRCEPENDERECO_COBRANCA`);
    }

    public async validateCEPCobranca({ component }: any) {
        const CEP = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NRCEPENDERECO_COBRANCA`).value.replace('-', '');
        if (CEP.length !== 8) {
            return;
        }

        LoadingService.show();
        try {
            const response = await this.searchCepCobranca(CEP) as IDictionary;
            const addressFound = response.data.dataset.ENDERECO;

            if (!addressFound) {
                return;
            }

            // Limpar campos de endereço antes de preencher com novos dados
            this.clearAddressFieldsCobranca({ component });

            Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-DSENDERECO_COBRANCA`).value = addressFound.DSENDERECO;
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_COBRANCA`).setValue(addressFound.CDPAIS ?? '');
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_COBRANCA`).setValue(addressFound.SGESTADO ?? '');
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_COBRANCA`).setValue(addressFound.CDMUNICIPIO ?? '');

            // Se o código do bairro estiver vazio, busca e preenche
            if (!addressFound.CDBAIRRO) {
                await this.fetchAndSetBairroCodeCobranca({ component }, addressFound);
            }
        } catch (error) {
            Utilities.showErrorMessage(error);
        } finally {
            LoadingService.hide();
        }
    }

    private async searchCepCobranca(cepValue: number): Promise<any | number> {
        if (String(cepValue).length === 8) {
            try {
                const response = await Http.post('/lib_findAddress', {
                    requestType: 'Row',
                    row: { CEP: cepValue },
                });
                return response;
            } catch (error) {
                console.error('Error searching for address:', error);
                return 0;
            }
        }
        return 0;
    }

    private clearAddressFieldsCobranca({ component }: any) {
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_COBRANCA`).setValue('');
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_COBRANCA`).setValue('');
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_COBRANCA`).setValue('');
    }

    private async fetchAndSetBairroCodeCobranca({ component }: any, addressFound: IDictionary): Promise<void> {
        try {
            const bairroResponse = await Http.post('/findCodeDistrict', {
                NMBAIRRO: addressFound.NMBAIRRO,
                CDPAIS: addressFound.CDPAIS,
                SGESTADO: addressFound.SGESTADO,
                CDMUNICIPIO: addressFound.CDMUNICIPIO,
            });
            const bairroData = bairroResponse.data.data[0];
            const CDBAIRRO = bairroData ? bairroData.CDBAIRRO : '';
            Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO_COBRANCA`).setValue(CDBAIRRO);
        } catch (error) {
            Utilities.showErrorMessage(error);
        }
    }

    public changeFieldStateCobranca({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_COBRANCA`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_COBRANCA`);
        const stateFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldState.name);

        if (component.value != null && component.name === statusFieldCountry.name) {
            stateFieldInstance.disabled = false;
            stateFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-CDPAIS_COBRANCA`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_COBRANCA`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_COBRANCA`);
            modalFieldState.disabled = false;
            modalFieldState.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
            });
        } else {
            stateFieldInstance.disabled = true;
            stateFieldInstance.value = null;
        }
    }

    public changeInTheMunicipalityFieldCobranca({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_COBRANCA`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_COBRANCA`);
        const statusFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_COBRANCA`);

        const municipalityFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldMunicipality.name);

        if (component.value != null && component.name === statusFieldState.name) {
            municipalityFieldInstance.disabled = false;
            municipalityFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
                SGESTADO: statusFieldState.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-SGESTADO_COBRANCA`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_COBRANCA`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_COBRANCA`);
            const modalFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_COBRANCA`);
            modalFieldMunicipality.disabled = false;
            modalFieldMunicipality.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
                SGESTADO: modalFieldState.value,
            });
        } else {
            municipalityFieldInstance.disabled = true;
            municipalityFieldInstance.value = null;
        }
    }

    public changeInTheNeighborhoodFieldCobranca({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_COBRANCA`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_COBRANCA`);
        const statusFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_COBRANCA`);
        const statusFieldNeighborhood = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO_COBRANCA`);

        const neighborhoodFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldNeighborhood.name);

        if (component.value != null && component.name === statusFieldMunicipality.name) {
            neighborhoodFieldInstance.disabled = false;
            neighborhoodFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
                SGESTADO: statusFieldState.value,
                CDMUNICIPIO: statusFieldMunicipality.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-CDMUNICIPIO_COBRANCA`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_COBRANCA`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_COBRANCA`);
            const modalFieldNeighborhood = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO_COBRANCA`);
            const modalFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_COBRANCA`);
            modalFieldNeighborhood.disabled = false;
            modalFieldNeighborhood.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
                SGESTADO: modalFieldState.value,
                CDMUNICIPIO: modalFieldMunicipality.value,
            });
        } else {
            neighborhoodFieldInstance.disabled = true;
            neighborhoodFieldInstance.value = null;
        }
    }

    // ABAIXO DADOS REFERENTE AO CEP DE EXTERIOR
    public showDialogWithButtonsGridExterior({ component }: any) {
        if (component.value.length === 8) {
            setTimeout(() => {
                DialogService.show({
                    name: 'dialog-find-partner-addres',
                    type: 'warning',
                    title: 'Buscar Endereço',
                    text: 'Deseja buscar o endereço pelo CEP?',
                    buttons: [
                        {
                            name: 'NAO',
                            component: 'ZdButton',
                            label: 'Não',
                            outline: true,
                            events: {
                                click: () => {
                                    DialogService.hide();
                                },
                            },
                        },
                        {
                            name: 'SIM',
                            component: 'ZdButton',
                            label: 'Sim',
                            events: {
                                click: () => {
                                    this.validateCEPExterior({ component });
                                    DialogService.hide();
                                },
                            },
                        },
                    ],
                });
            }, 100); // Pequeno atraso para garantir que o SDK carregue
        }
    }

    public validateExterior({ component }: any) {
        this.validateCEPExterior(`${component.name.split('-')[0]}-NRCEPENDERECO_EXTERIOR`);
    }

    public async validateCEPExterior({ component }: any) {
        const CEP = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NRCEPENDERECO_EXTERIOR`).value.replace('-', '');
        if (CEP.length !== 8) {
            return;
        }

        LoadingService.show();
        try {
            const response = await this.searchCepExterior(CEP) as IDictionary;
            const addressFound = response.data.dataset.ENDERECO;

            if (!addressFound) {
                return;
            }

            // Limpar campos de endereço antes de preencher com novos dados
            this.clearAddressFieldsExterior({ component });

            Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-DSENDERECO_EXTERIOR`).value = addressFound.DSENDERECO;
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_EXTERIOR`).setValue(addressFound.CDPAIS ?? '');
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_EXTERIOR`).setValue(addressFound.SGESTADO ?? '');
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_EXTERIOR`).setValue(addressFound.CDMUNICIPIO ?? '');

            // Se o código do bairro estiver vazio, busca e preenche
            if (!addressFound.CDBAIRRO) {
                await this.fetchAndSetBairroCodeExterior({ component }, addressFound);
            }
        } catch (error) {
            Utilities.showErrorMessage(error);
        } finally {
            LoadingService.hide();
        }
    }

    private async searchCepExterior(cepValue: number): Promise<any | number> {
        if (String(cepValue).length === 8) {
            try {
                const response = await Http.post('/lib_findAddress', {
                    requestType: 'Row',
                    row: { CEP: cepValue },
                });
                return response;
            } catch (error) {
                console.error('Error searching for address:', error);
                return 0;
            }
        }
        return 0;
    }

    private clearAddressFieldsExterior({ component }: any) {
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_EXTERIOR`).setValue('');
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_EXTERIOR`).setValue('');
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_EXTERIOR`).setValue('');
    }

    private async fetchAndSetBairroCodeExterior({ component }: any, addressFound: IDictionary): Promise<void> {
        try {
            const bairroResponse = await Http.post('/findCodeDistrict', {
                NMBAIRRO: addressFound.NMBAIRRO,
                CDPAIS: addressFound.CDPAIS,
                SGESTADO: addressFound.SGESTADO,
                CDMUNICIPIO: addressFound.CDMUNICIPIO,
            });
            const bairroData = bairroResponse.data.data[0];
            const CDBAIRRO = bairroData ? bairroData.CDBAIRRO : '';
            Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO_EXTERIOR`).setValue(CDBAIRRO);
        } catch (error) {
            Utilities.showErrorMessage(error);
        }
    }

    public changeFieldStateExterior({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_EXTERIOR`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_EXTERIOR`);
        const stateFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldState.name);

        if (component.value != null && component.name === statusFieldCountry.name) {
            stateFieldInstance.disabled = false;
            stateFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-CDPAIS_EXTERIOR`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_EXTERIOR`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_EXTERIOR`);
            modalFieldState.disabled = false;
            modalFieldState.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
            });
        } else {
            stateFieldInstance.disabled = true;
            stateFieldInstance.value = null;
        }
    }

    public changeInTheMunicipalityFieldExterior({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_EXTERIOR`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_EXTERIOR`);
        const statusFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_EXTERIOR`);

        const municipalityFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldMunicipality.name);

        if (component.value != null && component.name === statusFieldState.name) {
            municipalityFieldInstance.disabled = false;
            municipalityFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
                SGESTADO: statusFieldState.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-SGESTADO_EXTERIOR`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_EXTERIOR`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_EXTERIOR`);
            const modalFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_EXTERIOR`);
            modalFieldMunicipality.disabled = false;
            modalFieldMunicipality.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
                SGESTADO: modalFieldState.value,
            });
        } else {
            municipalityFieldInstance.disabled = true;
            municipalityFieldInstance.value = null;
        }
    }

    public changeInTheNeighborhoodFieldExterior({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_EXTERIOR`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_EXTERIOR`);
        const statusFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_EXTERIOR`);
        const statusFieldNeighborhood = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO_EXTERIOR`);

        const neighborhoodFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldNeighborhood.name);

        if (component.value != null && component.name === statusFieldMunicipality.name) {
            neighborhoodFieldInstance.disabled = false;
            neighborhoodFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
                SGESTADO: statusFieldState.value,
                CDMUNICIPIO: statusFieldMunicipality.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-CDMUNICIPIO_EXTERIOR`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_EXTERIOR`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_EXTERIOR`);
            const modalFieldNeighborhood = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO_EXTERIOR`);
            const modalFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_EXTERIOR`);
            modalFieldNeighborhood.disabled = false;
            modalFieldNeighborhood.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
                SGESTADO: modalFieldState.value,
                CDMUNICIPIO: modalFieldMunicipality.value,
            });
        } else {
            neighborhoodFieldInstance.disabled = true;
            neighborhoodFieldInstance.value = null;
        }
    }

    // ABAIXO DADOS REFERENTE AO CEP DE ENTREGA
    public showDialogWithButtonsGridEntrega({ component }: any) {
        if (component.value.length === 8) {
            setTimeout(() => {
                DialogService.show({
                    name: 'dialog-find-partner-addres',
                    type: 'warning',
                    title: 'Buscar Endereço',
                    text: 'Deseja buscar o endereço pelo CEP?',
                    buttons: [
                        {
                            name: 'NAO',
                            component: 'ZdButton',
                            label: 'Não',
                            outline: true,
                            events: {
                                click: () => {
                                    DialogService.hide();
                                },
                            },
                        },
                        {
                            name: 'SIM',
                            component: 'ZdButton',
                            label: 'Sim',
                            events: {
                                click: () => {
                                    this.validateCEPEntrega({ component });
                                    DialogService.hide();
                                },
                            },
                        },
                    ],
                });
            }, 100); // Pequeno atraso para garantir que o SDK carregue
        }
    }

    public validateEntrega({ component }: any) {
        this.validateCEPEntrega(`${component.name.split('-')[0]}-NRCEPENDERECO_ENTREGA`);
    }

    public async validateCEPEntrega({ component }: any) {
        const CEP = Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-NRCEPENDERECO_ENTREGA`).value.replace('-', '');
        if (CEP.length !== 8) {
            return;
        }

        LoadingService.show();
        try {
            const response = await this.searchCepEntrega(CEP) as IDictionary;
            const addressFound = response.data.dataset.ENDERECO;

            if (!addressFound) {
                return;
            }

            // Limpar campos de endereço antes de preencher com novos dados
            this.clearAddressFieldsEntrega({ component });

            Metadata.getInstance<TextInput>(`${component.name.split('-')[0]}-DSENDERECO_ENTREGA`).value = addressFound.DSENDERECO;
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_ENTREGA`).setValue(addressFound.CDPAIS ?? '');
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_ENTREGA`).setValue(addressFound.SGESTADO ?? '');
            await Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_ENTREGA`).setValue(addressFound.CDMUNICIPIO ?? '');

            // Se o código do bairro estiver vazio, busca e preenche
            if (!addressFound.CDBAIRRO) {
                await this.fetchAndSetBairroCodeEntrega({ component }, addressFound);
            }
        } catch (error) {
            Utilities.showErrorMessage(error);
        } finally {
            LoadingService.hide();
        }
    }

    private async searchCepEntrega(cepValue: number): Promise<any | number> {
        if (String(cepValue).length === 8) {
            try {
                const response = await Http.post('/lib_findAddress', {
                    requestType: 'Row',
                    row: { CEP: cepValue },
                });
                return response;
            } catch (error) {
                console.error('Error searching for address:', error);
                return 0;
            }
        }
        return 0;
    }

    private clearAddressFieldsEntrega({ component }: any) {
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_ENTREGA`).setValue('');
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_ENTREGA`).setValue('');
        Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_ENTREGA`).setValue('');
    }

    private async fetchAndSetBairroCodeEntrega({ component }: any, addressFound: IDictionary): Promise<void> {
        try {
            const bairroResponse = await Http.post('/findCodeDistrict', {
                NMBAIRRO: addressFound.NMBAIRRO,
                CDPAIS: addressFound.CDPAIS,
                SGESTADO: addressFound.SGESTADO,
                CDMUNICIPIO: addressFound.CDMUNICIPIO,
            });
            const bairroData = bairroResponse.data.data[0];
            const CDBAIRRO = bairroData ? bairroData.CDBAIRRO : '';
            Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO_ENTREGA`).setValue(CDBAIRRO);
        } catch (error) {
            Utilities.showErrorMessage(error);
        }
    }

    public changeFieldStateEntrega({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_ENTREGA`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_ENTREGA`);
        const stateFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldState.name);

        if (component.value != null && component.name === statusFieldCountry.name) {
            stateFieldInstance.disabled = false;
            stateFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-CDPAIS_ENTREGA`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_ENTREGA`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_ENTREGA`);
            modalFieldState.disabled = false;
            modalFieldState.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
            });
        } else {
            stateFieldInstance.disabled = true;
            stateFieldInstance.value = null;
        }
    }

    public changeInTheMunicipalityFieldEntrega({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_ENTREGA`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_ENTREGA`);
        const statusFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_ENTREGA`);

        const municipalityFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldMunicipality.name);

        if (component.value != null && component.name === statusFieldState.name) {
            municipalityFieldInstance.disabled = false;
            municipalityFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
                SGESTADO: statusFieldState.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-SGESTADO_ENTREGA`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_ENTREGA`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_ENTREGA`);
            const modalFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_ENTREGA`);
            modalFieldMunicipality.disabled = false;
            modalFieldMunicipality.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
                SGESTADO: modalFieldState.value,
            });
        } else {
            municipalityFieldInstance.disabled = true;
            municipalityFieldInstance.value = null;
        }
    }

    public changeInTheNeighborhoodFieldEntrega({ component }: any): void {
        const statusFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_ENTREGA`);
        const statusFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_ENTREGA`);
        const statusFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_ENTREGA`);
        const statusFieldNeighborhood = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO_ENTREGA`);

        const neighborhoodFieldInstance = Metadata.getInstance<SelectMultiple>(statusFieldNeighborhood.name);

        if (component.value != null && component.name === statusFieldMunicipality.name) {
            neighborhoodFieldInstance.disabled = false;
            neighborhoodFieldInstance.datasource.setFilter({
                CDPAIS: statusFieldCountry.value,
                SGESTADO: statusFieldState.value,
                CDMUNICIPIO: statusFieldMunicipality.value,
            });
        } else if (component.value != null && component.name === `${component.name.split('-')[0]}-CDMUNICIPIO_ENTREGA`) {
            const modalFieldCountry = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDPAIS_ENTREGA`);
            const modalFieldState = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-SGESTADO_ENTREGA`);
            const modalFieldNeighborhood = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-NMBAIRROENDERECO_ENTREGA`);
            const modalFieldMunicipality = Metadata.getInstance<Select>(`${component.name.split('-')[0]}-CDMUNICIPIO_ENTREGA`);
            modalFieldNeighborhood.disabled = false;
            modalFieldNeighborhood.datasource.setFilter({
                CDPAIS: modalFieldCountry.value,
                SGESTADO: modalFieldState.value,
                CDMUNICIPIO: modalFieldMunicipality.value,
            });
        } else {
            neighborhoodFieldInstance.disabled = true;
            neighborhoodFieldInstance.value = null;
        }
    }
}
