import { Utilities } from '@/util/Utilities';
import {
    Form, LoadingService, Select, TextInput,
} from '@zeedhi/common';
import { Http, Loader, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class Sm00029000TabLocalAtendimentoController {
    public gridLocalAtendimento = Loader.getInstance('Sm00029000LocalAtendimentoController');

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;

        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public editarLocalAtendimento() {
        const gridLocalAtendimento = Metadata.getInstance<TekGrid>('tek-grid-local_atendimento_grid');
        const params = {
            IDPADRAO: Metadata.getInstance<Select>('formDadosLocalAtendimento-IDPADRAO').value,
            VRTAMANHOLOGO: Metadata.getInstance<TextInput>('formDadosLocalAtendimento-VRTAMANHOLOGO').value,
            NRSEQCONTDOC: this.gridLocalAtendimento.currentRow.NRSEQCONTDOC,
        };
        LoadingService.show();
        Http.post('/editarLocalAtendimento', params)
            .then(() => {
                Utilities.showSuccessMessage();
                gridLocalAtendimento.datasource.get();
                this.gridLocalAtendimento.voltarTekGridLocalAtendimento();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }
}
